#include "stdafx.h"
#include "CpFlashDat.h"

CCpFlashDat::CCpFlashDat()
{

}

CCpFlashDat::~CCpFlashDat()
{

}

DWORD CCpFlashDat::LoadFlashDataInfo(const CHAR *pcDataBuff, CCpFlash &cpFlash)
{
	const CHAR *pcIndex = pcDataBuff;
	DWORD ulLength = 0;
	DWORD ulTempLength = 0;
	ENUM_FLASH_PRIORITY enumFlashPriority = _ENUM_FLASH_UNIQUE;
	ENUM_FLASH_IDCODE_TYPE enumIDType = _ENUM_FLASH_IDCODE_TYPE_9FAB;
	BYTE ucszTemp[UL_IDCODE_LEN] = {0};
	string strTemp;
	WORD usBankCount = 0;
	BYTE ucTemp = 0;
	BOOL bTemp = FALSE;

	// Flash IDCode Type
	ulTempLength = sizeof(ENUM_FLASH_IDCODE_TYPE);
	memcpy(&enumIDType, pcIndex, ulTempLength);
	cpFlash.SetIDType(enumIDType);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	// IDCode
	ulTempLength = sizeof(BYTE) * UL_IDCODE_LEN;
	memcpy(ucszTemp, pcIndex, ulTempLength);
	cpFlash.SetIDCode(ucszTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;
	memset(ucszTemp, 0, UL_IDCODE_LEN);

	// FlashName
	strTemp = pcIndex;
	ulTempLength = (DWORD)strTemp.length() + 1;
	cpFlash.SetFlashName(strTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;
	strTemp.clear();

	// BankCount
	ulTempLength = sizeof(WORD);
	memcpy(&usBankCount, pcIndex, ulTempLength);
	cpFlash.SetBankCount(usBankCount);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	// SRByteCount
	ulTempLength = sizeof(BYTE);
	memcpy(&ucTemp, pcIndex, ulTempLength);
	cpFlash.SetSRByteCount(ucTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;
	ucTemp = 0;

	//	m_enumPriority
	ulTempLength = sizeof(ENUM_FLASH_PRIORITY);
	memcpy(&enumFlashPriority, pcIndex, ulTempLength);
	cpFlash.SetFlashPriority(enumFlashPriority);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

    //OPCode m_ucszSROPCode[UL_SR_OPCODE_LEN]
	ulTempLength = sizeof(BYTE) * UL_SR_OPCODE_LEN;
	memcpy(ucszTemp, pcIndex, ulTempLength);
	cpFlash.SetSROPCode(ucszTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;
	memset(ucszTemp, 0, UL_IDCODE_LEN);

	// m_ucszEWPSR[UL_SR_MAX_COUNT]
	ulTempLength = sizeof(BYTE) * UL_SR_MAX_COUNT;
	memcpy(ucszTemp, pcIndex, ulTempLength);
	cpFlash.SetEWPSR(ucszTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;
	memset(ucszTemp, 0, UL_IDCODE_LEN);

	// m_ucszDWPSR[UL_SR_MAX_COUNT]
	ulTempLength = sizeof(BYTE) * UL_SR_MAX_COUNT;
	memcpy(ucszTemp, pcIndex, ulTempLength);
	cpFlash.SetDWPSR(ucszTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;
	memset(ucszTemp, 0, UL_IDCODE_LEN);

	// m_bEnableSWREN
	ulTempLength = sizeof(BOOL);
	memcpy(&bTemp, pcIndex, ulTempLength);
	cpFlash.SetEnableSWREN(bTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	// m_bSendSWRENEveryPage
	ulTempLength = sizeof(BOOL);
	memcpy(&bTemp, pcIndex, ulTempLength);
	cpFlash.SetSendSWRENEveryPage(bTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	// m_strSWRENCmd
	strTemp = pcIndex;
	ulTempLength = (DWORD)strTemp.length() + 1;
	cpFlash.SetSWRENCmd(strTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;
	strTemp.clear();

	// m_bEnableSafeGuard
	ulTempLength = sizeof(BOOL);
	memcpy(&bTemp, pcIndex, ulTempLength);
	cpFlash.SetEnableSafeGuard(bTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	// m_bSendSafeGuardCmdEveryPage
	ulTempLength = sizeof(BOOL);
	memcpy(&bTemp, pcIndex, ulTempLength);
	cpFlash.SetSendSWRENEveryPage(bTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	// m_strEnableSafeGuardCmd
	strTemp = pcIndex;
	ulTempLength = (DWORD)strTemp.length() + 1;
	cpFlash.SetEnableSafeGuardCmd(strTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	// m_strDisableSafeGuardCmd
	strTemp = pcIndex;
	ulTempLength = (DWORD)strTemp.length() + 1;
	cpFlash.SetDisableSafeGuardCmd(strTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	// m_ucWriteFlashSRCmd
	ulTempLength = sizeof(BYTE);
	memcpy(&ucTemp, pcIndex, ulTempLength);
	cpFlash.SetWriteFlashSRCmd(ucTemp);
	pcIndex += ulTempLength;
	ulLength += ulTempLength;

	return ulLength;
}

void CCpFlashDat::LoadFlashDat(string strPathPlusName, std::map<string, CCpFlash> &mapFlashInfo)
{
	std::map<string, CCpFlash>::iterator it;
	CHAR cszCurrentDir[MAX_DIR_LENGTH] = {0};
	//string strWorkPath;
	BYTE *pucBuff = NULL;
	BYTE *pucBuffIndex = NULL;
	DWORD ulFileLength = 0;
	DWORD ulTotalLength = 0;
	DWORD ulTempLength = 0;
	BOOL bReadDataBuff = TRUE;
	CCpFlash cpFlash;

	mapFlashInfo.clear();

	strncpy(cszCurrentDir, strPathPlusName.c_str(), sizeof(cszCurrentDir));

	ifstream fileFlashDat(cszCurrentDir, ios::in|ios::binary);
	if (fileFlashDat.is_open())
	{
		fileFlashDat.seekg (0, ios::end);
		ulFileLength = (DWORD)fileFlashDat.tellg();

		if(0 == ulFileLength)
		{
			fileFlashDat.close();
			// Remind error
			return;
		}
		pucBuff = new BYTE[ulFileLength];
		memset(pucBuff, 0, ulFileLength);

		pucBuffIndex = pucBuff;
		fileFlashDat.seekg (0, ios::beg);
		fileFlashDat.read((CHAR *)pucBuff, ulFileLength);

		// Load Head Info
		ulTempLength = sizeof(BYTE) * 4;
		memcpy(m_stHead.ucszFlag, pucBuffIndex, ulTempLength);
		pucBuffIndex += ulTempLength;
		ulTotalLength += ulTempLength;

	    if(memcmp(m_stHead.ucszFlag, UC_SZ_FLAG, sizeof(UC_SZ_FLAG)) != 0)
        {
            return;
        }

		ulTempLength = sizeof(WORD);
		memcpy(&m_stHead.usVersion, pucBuffIndex, ulTempLength);
		pucBuffIndex += ulTempLength;
		ulTotalLength += ulTempLength;

		ulTempLength = sizeof(WORD);
		memcpy(&m_stHead.usTotalFlash, pucBuffIndex, ulTempLength);
		pucBuffIndex += ulTempLength;
		ulTotalLength += ulTempLength;

		while(bReadDataBuff)
		{
			ulTempLength = LoadFlashDataInfo((CHAR *)pucBuffIndex, cpFlash);
			ulTotalLength += ulTempLength;

			if(ulTotalLength == ulFileLength)
			{
				bReadDataBuff = FALSE;
			}
			else if(ulTotalLength > ulFileLength)
			{
				//Remind Error
				fileFlashDat.close();
				delete [] pucBuff;
				pucBuff = NULL;
				return;
			}
			pucBuffIndex += ulTempLength;
			mapFlashInfo.insert(make_pair(cpFlash.GetFlashName(), cpFlash));
		}

		fileFlashDat.close();
		delete [] pucBuff;
		pucBuff = NULL;
	}

	return;
}

void CCpFlashDat::SaveFlashDat(string strPathPlusName, std::map<string, CCpFlash> mapFlashInfo)
{
	std::map<string, CCpFlash>::iterator it;
	CHAR cszCurrentDir[MAX_DIR_LENGTH] = {0};
	BYTE ucszTemp[UL_IDCODE_LEN] = {0};
	//string strWorkPath;
	BYTE *pucBuff = NULL;
	BYTE *pucBuffIndex = NULL;
	DWORD ulLength = 0;
	DWORD ulTempLength = 0;
	ENUM_FLASH_IDCODE_TYPE enumIDType = _ENUM_FLASH_IDCODE_TYPE_9FAB;
	ENUM_FLASH_PRIORITY enumFlashPriority = _ENUM_FLASH_UNIQUE;
	string strTemp;
	WORD usBankCount = 0;
	BYTE ucTemp = 0;
	BOOL bTemp = FALSE;

	strncpy(cszCurrentDir, strPathPlusName.c_str(), sizeof(cszCurrentDir));

	pucBuff = new BYTE[FLashDat_Max_Length];
	memset(pucBuff, 0, FLashDat_Max_Length);
	pucBuffIndex = pucBuff;

	m_stHead.usTotalFlash = (WORD)mapFlashInfo.size();
	//save Head Info
	ulTempLength = sizeof(BYTE) * 4;
	memcpy(pucBuffIndex, m_stHead.ucszFlag, ulTempLength);
	ulLength += ulTempLength;
	pucBuffIndex += ulTempLength;

	ulTempLength = sizeof(WORD);
	memcpy(pucBuffIndex, &m_stHead.usVersion, ulTempLength);
	ulLength += ulTempLength;
	pucBuffIndex += ulTempLength;

	ulTempLength = sizeof(WORD);
	memcpy(pucBuffIndex, &m_stHead.usTotalFlash, ulTempLength);
	ulLength += ulTempLength;
	pucBuffIndex += ulTempLength;

	for(it = mapFlashInfo.begin(); it != mapFlashInfo.end(); ++it)
	{
		// Store IDType
		ulTempLength = sizeof(ENUM_FLASH_IDCODE_TYPE);
		enumIDType = it->second.GetIDType();
		memcpy(pucBuffIndex, &enumIDType, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// Store IDCode
		ulTempLength = sizeof(BYTE) * UL_IDCODE_LEN;
		it->second.GetIDCode(ucszTemp);
		memcpy(pucBuffIndex, ucszTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;
		memset(ucszTemp, 0, UL_IDCODE_LEN);

		// Store FlashName
		strTemp = it->second.GetFlashName();
		ulTempLength = (DWORD)strTemp.length() + 1;
		CopyStringToBuff((CHAR *)pucBuffIndex, strTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// Store BankCount
		ulTempLength = sizeof(WORD);
		usBankCount = it->second.GetBankCount();
		memcpy(pucBuffIndex, &usBankCount, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// Store SRByteCount
		ulTempLength = sizeof(BYTE);
		ucTemp = it->second.GetSRByteCount();
		memcpy(pucBuffIndex, &ucTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// Store Flash Priority
		ulTempLength = sizeof(ENUM_FLASH_PRIORITY);
		enumFlashPriority = it->second.GetFlashPriority();
		memcpy(pucBuffIndex, &enumFlashPriority, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// Store OP Code, used to read high SR byte
		ulTempLength = sizeof(BYTE) * UL_SR_OPCODE_LEN;
		it->second.GetSROPCode(ucszTemp);
		memcpy(pucBuffIndex, ucszTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;
		memset(ucszTemp, 0, UL_IDCODE_LEN);

		// m_ucszEWPSR[UL_SR_MAX_COUNT]
		ulTempLength = sizeof(BYTE) * UL_SR_MAX_COUNT;
		it->second.GetEWPSR(ucszTemp);
		memcpy(pucBuffIndex, ucszTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;
		memset(ucszTemp, 0, UL_IDCODE_LEN);

		// m_ucszDWPSR[UL_SR_MAX_COUNT]
		ulTempLength = sizeof(BYTE) * UL_SR_MAX_COUNT;
		it->second.GetDWPSR(ucszTemp);
		memcpy(pucBuffIndex, ucszTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;
		memset(ucszTemp, 0, UL_IDCODE_LEN);

		// m_bEnableSWREN
		ulTempLength = sizeof(BOOL);
		bTemp = it->second.GetEnableSWREN();
		memcpy(pucBuffIndex, &bTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// m_bSendSWRENEveryPage
		ulTempLength = sizeof(BOOL);
		bTemp = it->second.GetSendSWRENEveryPage();
		memcpy(pucBuffIndex, &bTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// m_strSWRENCmd
		strTemp = it->second.GetSWRENCmd();
		ulTempLength = (DWORD)strTemp.length() + 1;
		CopyStringToBuff((CHAR *)pucBuffIndex, strTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;
		strTemp.clear();

		// m_bEnableSafeGuard
		ulTempLength = sizeof(BOOL);
		bTemp = it->second.GetEnableSafeGuard();
		memcpy(pucBuffIndex, &bTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// m_bSendSafeGuardCmdEveryPage
		ulTempLength = sizeof(BOOL);
		bTemp = it->second.GetSendSWRENEveryPage();
		memcpy(pucBuffIndex, &bTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// m_strEnableSafeGuardCmd
		strTemp = it->second.GetEnableSafeGuardCmd();
		ulTempLength = (DWORD)strTemp.length() + 1;
		CopyStringToBuff((CHAR *)pucBuffIndex, strTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// m_strDisableSafeGuardCmd
		strTemp = it->second.GetDisableSafeGuardCmd();
		ulTempLength = (DWORD)strTemp.length() + 1;
		CopyStringToBuff((CHAR *)pucBuffIndex, strTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;

		// m_ucWriteFlashSRCmd
		ulTempLength = sizeof(BYTE);
		ucTemp = it->second.GetWriteFlashSRCmd();
		memcpy(pucBuffIndex, &ucTemp, ulTempLength);
		ulLength += ulTempLength;
		pucBuffIndex += ulTempLength;
	}


	ofstream fileFlashDat(cszCurrentDir, ios::out|ios::binary);
	if (fileFlashDat.is_open())
	{
		fileFlashDat.write((CHAR *)pucBuff, ulLength);
		fileFlashDat.close();
	}

	delete [] pucBuff;
	pucBuff = NULL;

	return;
}

void CCpFlashDat::CopyStringToBuff(CHAR *pcDestBuff, string strSrc, DWORD ulLength)
{
	CHAR *pcTemp = NULL;
	pcTemp = new CHAR[ulLength];
	memset(pcTemp, 0, ulLength);
	strncpy(pcTemp, strSrc.c_str(), ulLength);
	memcpy(pcDestBuff, pcTemp, ulLength);
	delete[] pcTemp;
	pcTemp = NULL;
}

void CCpFlashDat::PrintFlashDat(string strPathPlusName, std::map<string, CCpFlash> mapFlashInfo)
{
	std::map<string, CCpFlash>::iterator it;
	CHAR cszCurrentDir[MAX_DIR_LENGTH] = {0};
	BYTE ucszTemp[UL_IDCODE_LEN] = {0};
	//string strWorkPath;
	string strTemp;
	DWORD ulTemp = 0;
	DWORD i = 0;
	//DWORD ulTempLength = 0;

	////õǰ· Glhubù·
	//getcwd(cszCurrentDir, MAX_DIR_LENGTH);

	//strWorkPath = cszCurrentDir;
	//strWorkPath += "\\Flash.txt";
	//ulTempLength = strWorkPath.length() + 1;
	//strncpy(cszCurrentDir, strWorkPath.c_str(), ulTempLength);
	strncpy(cszCurrentDir, strPathPlusName.c_str(), sizeof(cszCurrentDir));

	fstream fileFlashDat(cszCurrentDir, ios::out);
	if (fileFlashDat.is_open())
	{
		for(it = mapFlashInfo.begin();it != mapFlashInfo.end(); ++it)
		{
			fileFlashDat << "---    Name    ---   " << it->second.GetFlashName()  << endl;
			fileFlashDat << "---   IDType   ---   " << it->second.GetIDType() << endl;
			fileFlashDat << "---   IDCode   ---   ";

			it->second.GetIDCode(ucszTemp);
			for(i = 0; i <  UL_IDCODE_LEN; i++)
			{
				ulTemp = (DWORD)ucszTemp[i];
				fileFlashDat << setfill('0') << setw(2) << hex << ulTemp << " ";
			}
			fileFlashDat << endl;
			memset(ucszTemp, 0, UL_IDCODE_LEN);

			fileFlashDat << "---  BankCount ---   " << it->second.GetBankCount() << endl;
			ulTemp = (DWORD)it->second.GetSRByteCount();
			fileFlashDat << "--- SRByteCount---   " << hex << ulTemp << endl;
			fileFlashDat << "---  Priority  ---   " << it->second.GetFlashPriority() << endl;

			it->second.GetSROPCode(ucszTemp);
			ulTemp = (DWORD)ucszTemp[0];
			fileFlashDat << "---ReadHighSROP---   " << hex << ulTemp << endl;
			ulTemp = (DWORD)ucszTemp[1];
			fileFlashDat << "---ReadThirdSROP---  " <<  hex << ulTemp << endl;
			ulTemp = (DWORD)ucszTemp[2];
			fileFlashDat << "---WriteThirdSROP--- " << hex << ulTemp << endl;
			ulTemp = (DWORD)ucszTemp[3];
			fileFlashDat << "---ReadFourthSROP--- " << hex << ulTemp << endl;
			ulTemp = (DWORD)ucszTemp[4];
			fileFlashDat << "---WriteFourthSROP---" << hex << ulTemp << endl;
			memset(ucszTemp, 0, UL_IDCODE_LEN);

			it->second.GetEWPSR(ucszTemp);
			fileFlashDat << "---    EWPSR    ---  ";
			for(i = 0; i < UL_SR_MAX_COUNT; i++)
			{
				ulTemp = (DWORD)ucszTemp[i];
				fileFlashDat << setfill('0') << setw(2) << hex << ulTemp << " ";
			}
			fileFlashDat << endl;
			memset(ucszTemp, 0, UL_IDCODE_LEN);

			it->second.GetDWPSR(ucszTemp);
			fileFlashDat << "---    DWPSR    ---  ";
			for(i = 0; i < UL_SR_MAX_COUNT; i++)
			{
				ulTemp = (DWORD)ucszTemp[i];
				fileFlashDat << setfill('0') << setw(2) << hex << ulTemp << " ";
			}
			fileFlashDat << endl;
			memset(ucszTemp, 0, UL_IDCODE_LEN);

			fileFlashDat << "---  EnableSWREN --- " << it->second.GetEnableSWREN() << endl;
			fileFlashDat << "---SWREN EveryPage---" << it->second.GetSendSWRENEveryPage() << endl;
			fileFlashDat << "---   SWREN Cmd   ---" << it->second.GetSWRENCmd() << endl;
			fileFlashDat << "---   Enable SG   ---" << it->second.GetEnableSafeGuard() << endl;
			fileFlashDat << "--- SG EveryPage  ---" << it->second.GetSendSafeGuardCmdEveryPage() << endl;
			fileFlashDat << "--- Disable SG Cmd---" << it->second.GetDisableSafeGuardCmd() << endl;
			fileFlashDat << "--- Enable SG Cmd ---" << it->second.GetEnableSafeGuardCmd() << endl;
			fileFlashDat << "---WriteFlashSRCmd---" << hex << (DWORD)it->second.GetWriteFlashSRCmd() << endl;
			fileFlashDat << endl;
		}
	}
	fileFlashDat.close();
}

int CCpFlashDat::CharToInt(char cInput)
{
	if(cInput >= '0' && cInput <= '9')
		return cInput - '0';
	if(cInput >= 'A' && cInput <= 'F')
		return cInput - 'A' + 10;
	if(cInput >= 'a' && cInput <= 'f')
		return cInput - 'a' + 10;
	throw std::invalid_argument("Invalid Input");
}


BOOL CCpFlashDat::HexStringToByte(string strHex, BYTE* ucTarget, DWORD ulTargeLength)
{
	char *cszSrc = NULL;
	unsigned long ulLength = strHex.length();
	cszSrc = new char[ulLength];
	memset(cszSrc, 0, ulLength);
	strncpy(cszSrc, strHex.c_str(), ulLength);
	DWORD i = 0;

	if((strHex.length() % 2) > ulTargeLength)
	{
		return false;
	}
	for (i = 0; i < ulLength; )
	{
		*(ucTarget++) = (BYTE)CharToInt(cszSrc[i])*16 + (BYTE)CharToInt(cszSrc[i + 1]);
		i += 2;
	}
	delete [] cszSrc;
	cszSrc = NULL;
	return true;
}

//assume that string not contain "0x"
BOOL CCpFlashDat::CheckHexString(string strHex)
{
	string::iterator it;

	if((strHex.length() % 2) != 0 && (strHex.length() == 0))
	{
		return false;
	}
	for(it = strHex.begin(); it != strHex.end(); ++it)
	{
		if((*it >= '0' && *it <= '9') || (*it >= 'A' && *it <= 'F')
			|| (*it >= 'a' && *it <= 'f'))
		{
			continue;
		}
		else
		{
			return false;
		}
	}
	return true;
}

BOOL CCpFlashDat::StringCmdToByte(const string strSrc, BYTE *ucRtn, DWORD ulRtnLength)
{
	string strTemp = strSrc;
	BOOL bResult = false;

	strTemp.erase(std::remove(strTemp.begin(), strTemp.end(), ','), strTemp.end());

	bResult = CheckHexString(strTemp);
	if(!bResult)
	{
		return false;
	}
	bResult = HexStringToByte(strTemp, ucRtn, ulRtnLength);

	return bResult;
}


string CCpFlashDat::ByteCmdToString(BYTE *pucBuff, DWORD ulLength)
{
	string strTemp;
	string strCmd;
	CHAR cszTemp[6] = {0};
	DWORD i = 0;

	for(i = 0; i < ulLength; i++)
	{
		sprintf(cszTemp, "%02x,", pucBuff[i]);
		strTemp = cszTemp;
		strCmd += strTemp;
	}

	return strCmd;
}

BOOL CCpFlashDat::GetFlashInfoByFlashName(string strFlashName, std::map<string, CCpFlash> &mapFlashInfo, CCpFlash &cpFlash)
{
	std::map<string, CCpFlash>::iterator itCCpFlash;
	itCCpFlash = mapFlashInfo.find(strFlashName);

	if(itCCpFlash != mapFlashInfo.end())
	{
		cpFlash = itCCpFlash->second;
		return TRUE;
	}

	return FALSE;
}

BOOL CCpFlashDat::GetFlashInfoByIDCode(BYTE *pucIDCode, std::map<string, CCpFlash> &mapFlashInfo, CCpFlash &cpFlash)
{
    string strIDCode;
    DWORD ulSize = 0;
    vector <CCpFlash> cpFlashVec;
    vector <string> strFlashNameVec;
    std::map<string, CCpFlash>::iterator itCCpFlash;
    std::multimap<string, string>::iterator it,itLow, itUp;
	std::multimap<string, string> mapIDCodeFlashName;

	InitIDCodeToFlashNameMap(mapIDCodeFlashName, mapFlashInfo);

    strIDCode = ByteCmdToString(pucIDCode, UL_IDCODE_LEN);
    itLow = mapIDCodeFlashName.lower_bound(strIDCode);
    itUp = mapIDCodeFlashName.upper_bound(strIDCode);

    for(it = itLow; it != itUp; ++it)
    {
        strFlashNameVec.push_back(it->second);
    }

    if (strFlashNameVec.empty())
    {
        return false;
    }

    if(1 == strFlashNameVec.size())
    {
        itCCpFlash = mapFlashInfo.find(strFlashNameVec[0]);
		cpFlash = itCCpFlash->second;
    }
    else
    {
        for(ulSize = 0; ulSize < strFlashNameVec.size(); ulSize++)
        {
            itCCpFlash = mapFlashInfo.find(strFlashNameVec[ulSize]);
			cpFlash = itCCpFlash->second;
            if (cpFlash.GetFlashPriority() != _ENUM_FLASH_EQUAL)
            {
                break;
            }
        }
    }

    return true;
}


void CCpFlashDat::InitIDCodeToFlashNameMap(std::multimap<string, string> &mapIDCodeFlashName, std::map<string, CCpFlash> &mapFlashInfo)
{
    std::map<string, CCpFlash>::iterator it;
	BYTE ucszIDCode[UL_IDCODE_LEN] = {0};
	string strFlashName;
	string strIDCode;

	for(it = mapFlashInfo.begin(); it != mapFlashInfo.end(); ++it)
	{
		it->second.GetIDCode(ucszIDCode);
		strIDCode = ByteCmdToString(ucszIDCode, UL_IDCODE_LEN);
		strFlashName = it->second.GetFlashName();
		mapIDCodeFlashName.insert(make_pair(strIDCode, strFlashName));
	}
}

void CCpFlashDat::ReplaceByte(BYTE ucReplace, BYTE ucValue, BYTE *pucBuff, DWORD ulLength)
{
	DWORD i = 0;
	for(i = 0; i < ulLength; i++)
	{
		if(ucReplace == pucBuff[i])
		{
			pucBuff[i] = ucValue;
		}
	}
}
