#pragma once
#include "CpFlash.h"
#include <map>
#include <iomanip>
#include <algorithm>
#include <stdexcept>
#include <fstream>
#include <vector>

#define FLashDat_Max_Length 20480
CONST BYTE UC_SZ_FLAG[] = {9, 5, 2, 7};

typedef struct STRUCT_FLASHDAT_HEAD_INFO
{
	BYTE ucszFlag[4];// 9527
	WORD usVersion;// From 0, 1, 2
	WORD usTotalFlash;

	STRUCT_FLASHDAT_HEAD_INFO():usVersion(0), usTotalFlash(0)
	{
		memset(ucszFlag, 0, sizeof(ucszFlag));
	}

}STRUCT_FLASHDAT_HEAD_INFO;

class CCpFlashDat
{
public:
	CCpFlashDat();
	~CCpFlashDat();
	// Upload CCpFlash in Flash.Dat
    void LoadFlashDat(string strPathPlusName, std::map<string, CCpFlash> &mapFlashInfo);
	void SaveFlashDat(string strPathPlusName, std::map<string, CCpFlash> mapFlashInfo);
	void PrintFlashDat(string strPathPlusName, std::map<string, CCpFlash> mapFlashInfo);
	void CopyStringToBuff(CHAR *pcDestBuff, string strSrc, DWORD ulLength);
	//ulRtnLength = strSrc.length()/3,stringCmd like  EE, (length is 3) means one byte data  0xEE
	BOOL StringCmdToByte(const string strSrc, BYTE *ucRtn, DWORD ulRtnLength);
	string ByteCmdToString(BYTE *pucBuff, DWORD ulLength);
	BOOL GetFlashInfoByIDCode(BYTE *pucIDCode, std::map<string, CCpFlash> &mapFlashInfo, CCpFlash &cpFlash);
	void ReplaceByte(BYTE ucReplace, BYTE ucValue, BYTE *pucBuff, DWORD ulLength);
	BOOL GetFlashInfoByFlashName(string strFlashName, std::map<string, CCpFlash> &mapFlashInfo, CCpFlash &cpFlash);
private:
	STRUCT_FLASHDAT_HEAD_INFO m_stHead;
    //std::multimap<string, string> m_mapIDCodeFlashName;
	//std::map<string, CCpFlash> m_mapFlashInfo;
	int CharToInt(char cInput);
	BOOL CheckHexString(string strHex);
	BOOL HexStringToByte(string strHex, BYTE* ucTarget, DWORD ulTargeLength);
	DWORD LoadFlashDataInfo(const CHAR *pcDataBuff, CCpFlash &cpFlash);
    void InitIDCodeToFlashNameMap(std::multimap<string, string> &mapIDCodeFlashName, std::map<string, CCpFlash> &mapFlashInfo);
};
