#include "stdafx.h"
#include "CpIspFunc.h"
#include <time.h>

extern CCpIspFlowSetting *g_pcpIspSetting;
extern CCpRsString g_cpstrPath;
CCpRsString g_strLog;
CCpIspProgress g_cpIspProgress;



string GetTime()
{
	time_t timep;
	time(&timep);
	CHAR csztmp[64];
	strftime(csztmp, sizeof(csztmp), "[%Y-%m-%d %H:%M:%S] ", localtime(&timep));
	return csztmp;
}


void LogRecord(CCpRsString strLog)
{
	string strExePath, strLogPath, strTime, strLogRecord, strLogTemp;
	CHAR cszCurrentDir[MAX_DIR_LENGTH] = { 0 };

	if(g_pcpIspSetting->GetSaveDebugLog())
	{

		strExePath.assign(g_cpstrPath.begin(), g_cpstrPath.end());
		strLogTemp.assign(strLog.begin(), strLog.end());

		strLogPath = GetLogPathPlusName(strExePath);

		strTime = GetTime();
		strLogRecord = strTime + strLogTemp;

		strncpy(cszCurrentDir, strLogPath.c_str(), sizeof(cszCurrentDir));

		fstream out(cszCurrentDir, ios::out | ios::app);
		if(out.is_open())
		{
			out << strLogRecord << endl;
			out.close();
		}
	}

}

STRUCT_ENUM_ERROR_TYPE LoadProgramFw(string strFile, DWORD ulStartBank)
{
    DWORD ulFileLength, ulBankCnt = 0;
    std::map<DWORD, STRUCT_FW_BANK_SETTING, sortAscending<DWORD> > mapFw;
    std::map<DWORD, STRUCT_FW_BANK_SETTING, sortAscending<DWORD> >::iterator it;
    STRUCT_FW_BANK_SETTING stFwBank;
    ifstream file(strFile.c_str());

    if(!file.is_open())
    {
        return _ERROR_PLUGIN_ISP_OPEN_FILE_FAIL;
    }

    // Read file length
    file.seekg(0, ios::end);
    ulFileLength = (DWORD)file.tellg();
    file.seekg(0, ios::beg);
    file.close();

    ulBankCnt = (ulFileLength / 65536) + (ulFileLength % 65536 ? 1 : 0);
    g_pcpIspSetting->GetProgramFwMap(mapFw);

    for(DWORD ulIndex = 0; ulIndex < ulBankCnt; ++ulIndex)
    {
        it = mapFw.find(ulStartBank + ulIndex);
        if(it != mapFw.end())
        {
            return _ERROR_PLUGIN_ISP_TARGET_FLASH_BANK_DUPLICATION;
        }
        else
        {
            stFwBank.strFwPath = strFile;
            stFwBank.ulFwBank = ulIndex;
            mapFw.insert(std::make_pair(ulStartBank + ulIndex, stFwBank));
        }
    }
    
    g_pcpIspSetting->SetProgramFwMap(mapFw);

    return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE SetMcuRegDefaultValue()
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

	if(g_pcpRsComm->GetCommID() == _ENUM_COMM_TYPECUSB || g_pcpRsComm->GetCommID() == _ENUM_COMM_AUX || g_pcpRsComm->GetCommID() == _ENUM_COMM_LINUXDEVI2C)
	{
		return _ERROR_SUCCESS;
	}

	enumError = SetDDC0DDC1ADCDDCDebounce();
	IF_ERROR_THEN_RETURN(enumError);

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE SetDDC0DDC1ADCDDCDebounce()
{
	STRUCT_ENUM_ERROR_TYPE enumError;

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_1E, 0x02);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_1F, 0x30);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_20, 0x1C);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_2C, 0x02);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_2D, 0x30);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_2E, 0x1C);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_1B, 0x02);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_1C, 0x30);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_1D, 0x1C);
	IF_ERROR_THEN_RETURN(enumError);

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE SetDDC2Debounce()
{
	STRUCT_ENUM_ERROR_TYPE enumError;

	enumError = g_pcpRsComm->WriteRegEx(_REG_FE64, 0x02);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegEx(_REG_FE65, 0x30);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegEx(_REG_FE66, 0x1C);
	IF_ERROR_THEN_RETURN(enumError);
	return enumError;

}

STRUCT_ENUM_ERROR_TYPE SetDDC3Debounce()
{
	STRUCT_ENUM_ERROR_TYPE enumError;

	enumError = g_pcpRsComm->WriteRegEx(_REG_FE6D, 0x02);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegEx(_REG_FE6E, 0x30);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegEx(_REG_FE6F, 0x1C);
	IF_ERROR_THEN_RETURN(enumError);
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE SetDDC4Debounce()
{
	STRUCT_ENUM_ERROR_TYPE enumError;

	enumError = g_pcpRsComm->WriteRegEx(_REG_FE76, 0x02);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegEx(_REG_FE77, 0x30);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegEx(_REG_FE78, 0x1C);
	IF_ERROR_THEN_RETURN(enumError);
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE SetDDC5Debounce()
{
	STRUCT_ENUM_ERROR_TYPE enumError;

	enumError = g_pcpRsComm->WriteRegEx(_REG_FE7F, 0x02);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegEx(_REG_FE80, 0x30);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegEx(_REG_FE81, 0x1C);
	IF_ERROR_THEN_RETURN(enumError);
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE SetDDCDebounce()
{    
	return  SetDDC0DDC1ADCDDCDebounce();
}


// value high config
STRUCT_ENUM_ERROR_TYPE SetWPPin()
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    BYTE ucFlashMode = 0;
    // MCM Flash : Pin1005 pbd2
    //  Flash : Pin2 pbd7
    enumError = g_pcpRsComm->ReadRegEx(_REG_104B, &ucFlashMode);
    IF_ERROR_THEN_RETURN(enumError);

    if(ucFlashMode & _BIT7)
    {
        LogRecord(_T("Current is External Flash Mode!"));
        enumError = g_pcpRsComm->WriteRegBitEx(_REG_104F, 0xF8, 0x01);
        IF_ERROR_THEN_RETURN(enumError);

        enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE3F, 0xFE, 0x1);
        IF_ERROR_THEN_RETURN(enumError);

    }
    else
    {
        LogRecord(_T("Current is MCM Flash Mode!"));
        enumError = g_pcpRsComm->WriteRegBitEx(_REG_104A, 0xF8, 0x01);
        IF_ERROR_THEN_RETURN(enumError);

        enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE3A, 0xFE, 0x1);
        IF_ERROR_THEN_RETURN(enumError);

    }

	return _ERROR_SUCCESS;
}

void ResetMcu()
{
	g_pcpRsComm->WriteMcuRegBit(_MCUREG_EE, 0xFD, _BIT1);
	return;
}

void ResetMcuAsSetting()
{

	if(g_pcpIspSetting->GetResetMcu() || (IS_Digital_HW_Sign_Verify(g_pcpIspSetting->GetIspFunctionType())))
	{
		g_pcpRsComm->WriteMcuRegBit(_MCUREG_EE, 0xFD, _BIT1);
	}

	return;
}

STRUCT_ENUM_ERROR_TYPE EnterIspMode(WORD usRetryTimes)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	BOOL bRemindInfo = FALSE;
	CCpRsString str;
	DWORD i = 0, j = 0;
    STRUCT_WAITING_STRUCT stWaiting = {_WAITING_NONE, 0};

   
    g_pcpRsComm->SetDebugMode(_DEBUG_ISP);
    
    if(g_pcpRsComm->GetCommID() == _ENUM_COMM_REALTEKUSB)
    {
        enumError = g_pcpRsComm->SetWaitingMode(stWaiting);
        IF_ERROR_THEN_RETURN(enumError);
    }

	if(g_pcpIspSetting->GetIspBeforeAcOn())
	{
		i = CpRsGetTickCount();
		bRemindInfo = FALSE;
		do
		{
			if(g_pcpIspSetting->GetAutoDetectSlave())
			{
				enumError = g_pcpRsComm->AutoEnterIspMode(1);
			}
			else
			{
				enumError = g_pcpRsComm->SetIspSlave(g_pcpIspSetting->GetSpecifiedSlave());
				enumError = g_pcpRsComm->EnterIspMode(1);
			}
			if((j > 1000) && (!bRemindInfo))
			{
				bRemindInfo = TRUE;
				LogRecord(_T("Trying into ISP mode..."));
			}
			if(_ERROR_SUCCESS == enumError)
			{
				if(bRemindInfo)
				{
					LogRecord(_T(" Success"));
				}
				break;
			}
			j = CpRsGetTickCount();
			j -= i;
		} while (j < g_pcpIspSetting->GetTimeBeforeAcOn());
	}
	else
	{
		if(g_pcpIspSetting->GetAutoDetectSlave())
		{
			g_pcpRsComm->AutoEnterIspMode(usRetryTimes);
		}
		else
		{
			g_pcpRsComm->SetIspSlave(g_pcpIspSetting->GetSpecifiedSlave());
			enumError = g_pcpRsComm->EnterIspMode(usRetryTimes);
		}
	}
	if(_ERROR_SUCCESS != enumError)
	{
		str.Format(_T("Enter ISP mode fail! Error code:0x%X."), enumError);
		LogRecord(str);
		return enumError;
	}

	return enumError;
}

// Wait until result == (ucTarget & unAnd) or nTryCount == 0, the later one return False
STRUCT_ENUM_ERROR_TYPE WaitForBitChange(BYTE ucRegister, BYTE ucAnd, BYTE ucTarget, INT nTryCount)
{
	BYTE ucData = 0;
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	INT nCommunicateCount = 5;

	ucTarget &= ucAnd;
	while (nTryCount > 0)
	{
		enumError = g_pcpRsComm->ReadMcuReg(ucRegister, &ucData);
		if(enumError != _ERROR_SUCCESS)
		{
			if(--nCommunicateCount > 0)
			{
				continue;
			}
			else
			{
				break;
			}
		}
		if((ucData & ucAnd) == ucTarget)
		{
			return _ERROR_SUCCESS;
		}

		Sleep(2);

		--nTryCount;
	}

	return _ERROR_COMMONFUNC_POLLINGFAIL;
}

//////////////////////////////////////////////////////////////////////////
// Run the command
// Input: pucCmd: command data
//        ulCmdLength: command length
//        pstComm: communication interface
//        pucOutput: data buffer to be used to save read data
// Return: error type
//////////////////////////////////////////////////////////////////////////
STRUCT_ENUM_ERROR_TYPE RunCommand(BYTE* pucCmd, DWORD ulCmdLength, CCpRsComm* pcpRsComm, BYTE* pucOutput, DWORD *pulOutPutLen)
{
	BYTE ucReadValue = 0;
	WORD usCount = 0, usTime = 0, usReg = 0, usData = 0, usLength = 0;
	DWORD ulIndex = 0;
	DWORD ulValue = 0;
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	STRUCT_ENUM_INC_TYPE enumInc = _INCTYPE_NONE;
	DWORD ul32BitReg = 0, ul32BitValue = 0;

	while (ulIndex < ulCmdLength)
	{
		switch (pucCmd[ulIndex])
		{
		case _ENUM_CMD_SLEEP:
			ulValue = ((WORD)pucCmd[ulIndex + 1] << 8) + pucCmd[ulIndex + 2];
			Sleep(ulValue);
			ulIndex += 3;
			break;

		case _ENUM_CMD_SCALERRUN:
			enumError = pcpRsComm->ScalerRun();
			ulIndex++;
			break;

		case _ENUM_CMD_SCALERSTOP:
			enumError = pcpRsComm->ScalerStop();
			ulIndex++;
			break;

		case _ENUM_CMD_WRITEREG:
			enumError = pcpRsComm->WriteReg(pucCmd[ulIndex + 1], pucCmd[ulIndex + 2]);
			ulIndex += 3;
			break;

		case _ENUM_CMD_WRITEREGBIT:
			enumError = pcpRsComm->WriteRegBit(pucCmd[ulIndex + 1], pucCmd[ulIndex + 2], pucCmd[ulIndex + 3]);
			ulIndex += 4;
			break;

		case _ENUM_CMD_WRITEPORTREGBIT:
			enumError = pcpRsComm->WritePortRegBit(pucCmd[ulIndex + 1], pucCmd[ulIndex + 2], pucCmd[ulIndex + 3], pucCmd[ulIndex + 4]);
			ulIndex += 5;
			break;

		case _ENUM_CMD_READREG:
			if(pucOutput != NULL)
			{
				enumError = pcpRsComm->ReadReg(pucCmd[ulIndex + 1], pucOutput);
				pucOutput++;
				ulIndex += 2;
				if(pulOutPutLen != NULL)
				{
					(*pulOutPutLen)++;
				}
			}
			else
			{
				enumError = _ERROR_COMMONFUNC_OUTPUT;
			}
			break;

		case _ENUM_CMD_WRITEMUCREG:
			enumError = pcpRsComm->WriteMcuReg(pucCmd[ulIndex + 1], pucCmd[ulIndex + 2]);
			ulIndex += 3;
			break;

		case _ENUM_CMD_WRITEMCUREGBIT:
			enumError = pcpRsComm->WriteMcuRegBit(pucCmd[ulIndex + 1], pucCmd[ulIndex + 2], pucCmd[ulIndex + 3]);
			ulIndex += 4;
			break;

		case _ENUM_CMD_READMCUREG:
			if(pucOutput != NULL)
			{
				enumError = pcpRsComm->ReadMcuReg(pucCmd[ulIndex + 1], pucOutput);
				pucOutput++;
				ulIndex += 2;
				if(pulOutPutLen != NULL)
				{
					(*pulOutPutLen)++;
				}
			}
			else
			{
				enumError = _ERROR_COMMONFUNC_OUTPUT;
			}
			break;

		case _ENUM_CMD_I2CWRITEBYTE:
			enumError = pcpRsComm->I2CWriteByte(pucCmd[ulIndex + 1], pucCmd[ulIndex + 2], pucCmd[ulIndex + 3]);
			ulIndex += 4;
			break;

		case _ENUM_CMD_I2CREADBYTE:
			if(pucOutput != NULL)
			{
				enumError = pcpRsComm->I2CRead(pucCmd[ulIndex + 1], pucCmd[ulIndex + 2], 1, pucOutput);
				pucOutput++;
				ulIndex += 3;
				if(pulOutPutLen != NULL)
				{
					(*pulOutPutLen)++;
				}
			}
			else
			{
				enumError = _ERROR_COMMONFUNC_OUTPUT;
			}
			break;

		case _ENUM_CMD_I2C2SUBWRITEBYTE:
			enumError = _ERROR_COMMONFUNC_OUTPUT;
			break;

		case _ENUM_CMD_I2C2SUBREADBYTE:
			enumError = _ERROR_COMMONFUNC_OUTPUT;
			break;

		case _ENUM_CMD_I2CCURRENTREAD:
			if(pucOutput != NULL)
			{
				enumError = pcpRsComm->I2CCurrentRead(pucCmd[ulIndex + 1], 1, pucOutput);
				pucOutput++;
				ulIndex += 2;
				if(pulOutPutLen != NULL)
				{
					(*pulOutPutLen)++;
				}
			}
			else
			{
				enumError = _ERROR_COMMONFUNC_OUTPUT;
			}
			break;

		case _ENUM_CMD_POLLING_MCUREG:
			usCount = (WORD)(pucCmd[ulIndex + 4] << 8) + pucCmd[ulIndex + 5];
			usTime = (WORD)(pucCmd[ulIndex + 6] << 8) + pucCmd[ulIndex + 7];
			ulValue = 0;
			while (ulValue < usCount)
			{
				enumError = pcpRsComm->ReadMcuReg(pucCmd[ulIndex + 1], &ucReadValue);
				if(enumError == _ERROR_SUCCESS)
				{
					if((ucReadValue & pucCmd[ulIndex + 2]) == (pucCmd[ulIndex + 3] & pucCmd[ulIndex + 2]))//add & pucCmd[ulIndex + 2]??
					{
						break;
					}
				}
				else
				{
					break;
				}

				Sleep(usTime);
				ulValue++;
			}

			// Polling fail
			if(ulValue >= usCount)
			{
				enumError = _ERROR_COMMONFUNC_POLLINGFAIL;
			}
			ulIndex += 8;// Add by dimy_chen
			break;

		case _ENUM_CMD_WRITEREG_EX:
			usReg = pucCmd[ulIndex + 1];
			usReg = (usReg << 8) | pucCmd[ulIndex + 2];
			enumError = pcpRsComm->WriteRegEx(usReg, pucCmd[ulIndex + 3]);
			ulIndex += 4;
			break;

		case _ENUM_CMD_WRITEREGBIT_EX:
			usReg = pucCmd[ulIndex + 1];
			usReg = (usReg << 8) | pucCmd[ulIndex + 2];
			enumError = pcpRsComm->WriteRegBitEx(usReg, pucCmd[ulIndex + 3], pucCmd[ulIndex + 4]);
			ulIndex += 5;
			break;

		case _ENUM_CMD_READREG_EX:
			if(pucOutput != NULL)
			{
				usReg = pucCmd[ulIndex + 1];
				usReg = (usReg << 8) | pucCmd[ulIndex + 2];
				enumError = pcpRsComm->ReadRegEx(usReg, pucOutput);
				pucOutput++;
				ulIndex += 3;
				if(pulOutPutLen != NULL)
				{
					(*pulOutPutLen)++;
				}
			}
			else
			{
				enumError = _ERROR_COMMONFUNC_OUTPUT;
			}
			break;

		case _ENUM_CMD_WRITEPORTREGBIT_EX:
			usReg = pucCmd[ulIndex + 1];
			usReg = (usReg << 8) | pucCmd[ulIndex + 2];
			usData = pucCmd[ulIndex + 3];
			usData = (usData << 8) | pucCmd[ulIndex + 4];
			enumError = pcpRsComm->WritePortRegBitEx(usReg, usData, pucCmd[ulIndex + 5], pucCmd[ulIndex + 6]);
			ulIndex += 7;
			break;
		case _ENUM_CMD_WRITEREGS_EX:
			usReg = pucCmd[ulIndex + 1];
			usReg = (usReg << 8) | pucCmd[ulIndex + 2];
			usLength = pucCmd[ulIndex + 3];
			usLength = (usLength << 8) | pucCmd[ulIndex + 4];
			enumInc = (STRUCT_ENUM_INC_TYPE)pucCmd[ulIndex + 5];
			enumError = pcpRsComm->WriteRegsEx(usReg, usLength, pucCmd + ulIndex + 6, enumInc);
			ulIndex += (6 + usLength);
			break;
		case _ENUM_CMD_READREGS_EX:
			usReg = pucCmd[ulIndex + 1];
			usReg = (usReg << 8) | pucCmd[ulIndex + 2];
			usLength = pucCmd[ulIndex + 3];
			usLength = (usLength << 8) | pucCmd[ulIndex + 4];
			enumInc = (STRUCT_ENUM_INC_TYPE)pucCmd[ulIndex + 5];
			enumError = pcpRsComm->ReadRegsEx(usReg, usLength, pucOutput, enumInc);
			ulIndex += 6;
			pucOutput += usLength;
			if(pulOutPutLen != NULL)
			{
				(*pulOutPutLen) += usLength;
			}
			break;
		case _ENUM_CMD_WRITEREGS:
			usLength = pucCmd[ulIndex + 2];
			usLength = (usLength << 8) | pucCmd[ulIndex + 3];
			enumInc = (STRUCT_ENUM_INC_TYPE)pucCmd[ulIndex + 4];
			enumError = pcpRsComm->WriteRegs(pucCmd[ulIndex + 1], usLength, pucCmd + ulIndex + 5, enumInc);
			ulIndex += (5 + usLength);
			break;
		case _ENUM_CMD_READREGS:
			usLength = pucCmd[ulIndex + 2];
			usLength = (usLength << 8) | pucCmd[ulIndex + 3];
			enumInc = (STRUCT_ENUM_INC_TYPE)pucCmd[ulIndex + 4];
			enumError = pcpRsComm->ReadRegs(pucCmd[ulIndex + 1], usLength, pucOutput, enumInc);
			ulIndex += 5;
			pucOutput += usLength;
			if(pulOutPutLen != NULL)
			{
				(*pulOutPutLen) += usLength;
			}
			break;
		case _ENUM_CMD_WRITEMCUREGS:
			usReg = pucCmd[ulIndex + 1];
			usReg = (usReg << 8) | pucCmd[ulIndex + 2];
			usLength = pucCmd[ulIndex + 3];
			usLength = (usLength << 8) | pucCmd[ulIndex + 4];
			enumInc = (STRUCT_ENUM_INC_TYPE)pucCmd[ulIndex + 5];
			enumError = pcpRsComm->WriteMcuRegs(usReg, usLength, pucCmd + ulIndex + 6, enumInc);
			ulIndex += (6 + usLength);
			break;
		case _ENUM_CMD_READMCUREGS:
			usReg = pucCmd[ulIndex + 1];
			usReg = (usReg << 8) | pucCmd[ulIndex + 2];
			usLength = pucCmd[ulIndex + 3];
			usLength = (usLength << 8) | pucCmd[ulIndex + 4];
			enumInc = (STRUCT_ENUM_INC_TYPE)pucCmd[ulIndex + 5];
			enumError = pcpRsComm->ReadMcuRegs(usReg, usLength, pucOutput, enumInc);
			ulIndex += 6;
			pucOutput += usLength;
			if(pulOutPutLen != NULL)
			{
				(*pulOutPutLen) += usLength;
			}
			break;
		case _ENUM_CMD_WRITE32REG:
			ul32BitReg = ((DWORD)pucCmd[ulIndex + 1] << 24) | ((DWORD)pucCmd[ulIndex + 2] << 16) | ((DWORD)pucCmd[ulIndex + 3] << 8) | pucCmd[ulIndex + 4];
			ul32BitValue = ((DWORD)pucCmd[ulIndex + 5] << 24) | ((DWORD)pucCmd[ulIndex + 6] << 16) | ((DWORD)pucCmd[ulIndex + 7] << 8) | pucCmd[ulIndex + 8];
			enumError = pcpRsComm->Write32BitRegEx(ul32BitReg, ul32BitValue);
			ulIndex += (9 + usLength);
			break;
		default:
			enumError = _ERROR_COMMONFUNC_CMD;
			break;
		}

		if(enumError != _ERROR_SUCCESS)
		{
			return enumError;
		}
	}

	return enumError;
}

// Read SR
STRUCT_ENUM_ERROR_TYPE ReadFlashSR(BYTE& ucSRValue, BYTE ucOPCode)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x42);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, ucOPCode);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x43);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 1000);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_67, &ucSRValue);
	IF_ERROR_THEN_RETURN(enumError);

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteFlashSR(BYTE *pucSRValue, CCpFlash *pcpFlash)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	BYTE *pucSWREN = NULL;
	DWORD ulTempLen = 0;
	string strCmd;
	CCpFlashDat cpFlashDat;
	BYTE ucszSROPCode[UL_SR_OPCODE_LEN] = { 0 };
	DWORD i = 0;
	BYTE ucOPCode = 0;

	pcpFlash->GetSROPCode(ucszSROPCode);
	// Send special WREN
	if(pcpFlash->GetEnableSWREN())
	{
		strCmd = pcpFlash->GetSWRENCmd();
		ulTempLen = (DWORD)strCmd.length() / 3;
		pucSWREN = new BYTE[ulTempLen];
		if(!cpFlashDat.StringCmdToByte(strCmd, pucSWREN, ulTempLen))
		{
			SAFELY_DELETE(pucSWREN);
			return _ERROR_PLUGIN_ISP_CMD_STRING_TO_BYTE;
		}

		enumError = RunCommand(pucSWREN, ulTempLen, g_pcpRsComm, NULL);
		SAFELY_DELETE(pucSWREN);
		IF_ERROR_THEN_RETURN(enumError);
	}

	for(i = 0; i < pcpFlash->GetSRByteCount(); i++)
	{
		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x68);
		IF_ERROR_THEN_RETURN(enumError);

		// OP Code
		switch(i)
		{
		case 0:
			ucOPCode = 0x1;
				break;
		case 1:
			ucOPCode = 0x31;
			break;
		case 2:
			ucOPCode = ucszSROPCode[2];
			break;
		case 3:
			ucOPCode = ucszSROPCode[4];
			break;
		default:
			return _ERROR_PLUGIN_ISP_WRITE_FLASH_SR_OPCODE;
			break;
		}

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, ucOPCode);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, pucSRValue[i]);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x69);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 600);
		IF_ERROR_THEN_RETURN(enumError);
	}

	return enumError;
}

// Read CRC
STRUCT_ENUM_ERROR_TYPE ReadCRC(DWORD ulBankIndex, WORD usStartAddr, DWORD ulCount, BYTE* pucCRC)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

	// Start address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, (BYTE)ulBankIndex);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, (usStartAddr & 0xFF00) >> 8);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, usStartAddr & 0x00FF);
	IF_ERROR_THEN_RETURN(enumError);

	//End address
	usStartAddr += (WORD)(ulCount - 1);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_72, (BYTE)ulBankIndex);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_73, (usStartAddr & 0xFF00) >> 8);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_74, usStartAddr & 0x00FF);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_6F, 0xFF, _BIT2);
	IF_ERROR_THEN_RETURN(enumError);

	// Wait for 6F[2] be clear
	enumError = WaitForBitChange(_MCUREG_6F, _BIT2, 0, 600);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_75, pucCRC);
	IF_ERROR_THEN_RETURN(enumError);

	return enumError;
}

//////////////////////////////////////////////////////////////////////////
// Calculate the buffer CRC
// Input: pucBuf: data buffer point
//        ulLength: buffer length
// Return: CRC value
//////////////////////////////////////////////////////////////////////////
BYTE CalculateByteCRC(LPBYTE pucData, DWORD ulLength)
{
	DWORD ulIndex = 0;
	INT i = 0;
	BYTE ucResult = 0;
	BOOL bDataBit[8] = { 0 }, bTempCRC[8] = { 0 }, bLastCRC[8] = { 0 };

	for(ulIndex = 0; ulIndex < ulLength; ulIndex++)
	{
		bDataBit[0] = (pucData[ulIndex] & _BIT0) ? 1 : 0;
		bDataBit[1] = (pucData[ulIndex] & _BIT1) ? 1 : 0;
		bDataBit[2] = (pucData[ulIndex] & _BIT2) ? 1 : 0;
		bDataBit[3] = (pucData[ulIndex] & _BIT3) ? 1 : 0;
		bDataBit[4] = (pucData[ulIndex] & _BIT4) ? 1 : 0;
		bDataBit[5] = (pucData[ulIndex] & _BIT5) ? 1 : 0;
		bDataBit[6] = (pucData[ulIndex] & _BIT6) ? 1 : 0;
		bDataBit[7] = (pucData[ulIndex] & _BIT7) ? 1 : 0;

		bTempCRC[0] = bDataBit[7] ^ bDataBit[6] ^ bDataBit[0] ^ bLastCRC[7] ^ bLastCRC[6] ^ bLastCRC[0];
		bTempCRC[1] = bDataBit[6] ^ bDataBit[1] ^ bDataBit[0] ^ bLastCRC[6] ^ bLastCRC[1] ^ bLastCRC[0];
		bTempCRC[2] = bDataBit[6] ^ bDataBit[2] ^ bDataBit[1] ^ bDataBit[0] ^ bLastCRC[6] ^ bLastCRC[2] ^ bLastCRC[1] ^ bLastCRC[0];
		bTempCRC[3] = bDataBit[7] ^ bDataBit[3] ^ bDataBit[2] ^ bDataBit[1] ^ bLastCRC[7] ^ bLastCRC[3] ^ bLastCRC[2] ^ bLastCRC[1];
		bTempCRC[4] = bDataBit[4] ^ bDataBit[3] ^ bDataBit[2] ^ bLastCRC[4] ^ bLastCRC[3] ^ bLastCRC[2];
		bTempCRC[5] = bDataBit[5] ^ bDataBit[4] ^ bDataBit[3] ^ bLastCRC[5] ^ bLastCRC[4] ^ bLastCRC[3];
		bTempCRC[6] = bDataBit[6] ^ bDataBit[5] ^ bDataBit[4] ^ bLastCRC[6] ^ bLastCRC[5] ^ bLastCRC[4];
		bTempCRC[7] = bDataBit[7] ^ bDataBit[6] ^ bDataBit[5] ^ bLastCRC[7] ^ bLastCRC[6] ^ bLastCRC[5];

		for(i = 0; i < 8; i++)
		{
			bLastCRC[i] = bTempCRC[i];
		}
	}

	ucResult = 0;
	for(i = 0; i < 8; i++)
	{
		if(bLastCRC[i])
		{
			ucResult = ucResult + (1 << i);
		}
	}

	return ucResult;
}

STRUCT_ENUM_ERROR_TYPE ChipErase(CCpFlash *pcpFlash)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	DWORD ulBankIndex = 0;
	BYTE ucBankCRC = 0;
	BYTE ucszDWPSR[4] = { 0 };

	// Because chipErase takes long time, so show message
	LogRecord(_T("Chip erasing..."));

	// If flash has SWREN Every Page, disable WP
	if(pcpFlash->GetSendSWRENEveryPage())
	{
		pcpFlash->GetDWPSR(ucszDWPSR);
		enumError = WriteFlashSR(ucszDWPSR, pcpFlash);
		IF_ERROR_THEN_RETURN(enumError);
	}

	// Chip Erase
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0xA0);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0xC7);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0xA1);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 20000);
	IF_ERROR_THEN_RETURN(enumError);

	// Check CRC
	for(ulBankIndex = 0; ulBankIndex < pcpFlash->GetBankCount(); ++ulBankIndex)
	{
		enumError = ReadCRC(ulBankIndex, 0x00, UL_MAX_SERIALBANK_LENGTH, &ucBankCRC);
		IF_ERROR_THEN_RETURN(enumError);

		if(ucBankCRC != UC_ERASE_BANK_CRC)
		{
			return _ERROR_PLUGIN_ISP_CRC_DIFFERENT_ERASE_FAIL;
		}
	}

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE BankErase(DWORD ulBankIndex, CCpFlash *pcpFlash)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	BYTE ucBankCRC = 0;
	BYTE ucszDWPSR[4] = { 0 };

	// If flash has SWREN, disable WP
	if(pcpFlash->GetSendSWRENEveryPage())
	{
		pcpFlash->GetDWPSR(ucszDWPSR);
		enumError = WriteFlashSR(ucszDWPSR, pcpFlash);
		IF_ERROR_THEN_RETURN(enumError);
	}

	// Bank Erase
	// Write address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, (BYTE)ulBankIndex);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, (BYTE)0);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, (BYTE)0);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0xB8);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0xD8);// OP code
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0xB9);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 600);
	IF_ERROR_THEN_RETURN(enumError);
	// When process more than 1 band, WaitForBitChange() just say the fastest band had done, not all the band.
	// So should wait a while for the lower ones
	if(g_pcpRsComm->GetCommID() != _ENUM_COMM_TYPECUSB)
	{
		// Check CRC
		enumError = ReadCRC(ulBankIndex, 0x00, UL_MAX_SERIALBANK_LENGTH, &ucBankCRC);
		IF_ERROR_THEN_RETURN(enumError);
		if(ucBankCRC != UC_ERASE_BANK_CRC)
		{
			return _ERROR_PLUGIN_ISP_CRC_DIFFERENT_ERASE_FAIL;
		}
	}

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE SectorErase(DWORD ulBankIndex, DWORD ulSectorIndex, CCpFlash* pcpFlash)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	BYTE ucSectorCRC = 0;
	BYTE ucszDWPSR[4] = { 0 };

	// If flash has SWREN E, disable WP
	if(pcpFlash->GetSendSWRENEveryPage())
	{
		pcpFlash->GetDWPSR(ucszDWPSR);
		enumError = WriteFlashSR(ucszDWPSR, pcpFlash);
		IF_ERROR_THEN_RETURN(enumError);
	}

	// Sector Erase
	// Write address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, (BYTE)ulBankIndex);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, (BYTE)(ulSectorIndex << 4));
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, (BYTE)0);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0xB8);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x20);// OP code
	IF_ERROR_THEN_RETURN(enumError);

	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0xB9);
	IF_ERROR_THEN_RETURN(enumError);

	enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 600);
	IF_ERROR_THEN_RETURN(enumError);
	// When process more than 1 band, WaitForBitChange() just say the fastest band had done, not all the band.
	// So should wait a while for the lower ones
	if(g_pcpRsComm->GetCommID() != _ENUM_COMM_TYPECUSB)
	{
		// Check CRC
		enumError = ReadCRC(ulBankIndex, (WORD)(ulSectorIndex << 12), UL_SECTOR_LEN, &ucSectorCRC);
		IF_ERROR_THEN_RETURN(enumError);

		if(ucSectorCRC != UC_ERASE_SECTOR_CRC)
		{
			return _ERROR_PLUGIN_ISP_CRC_DIFFERENT_ERASE_FAIL;
		}
	}

	return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE ReadFlashData(WORD usBankAddr, DWORD ulStartAddr, DWORD ulCount, BYTE* pucBuff)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	DWORD ulReadPageCount = ulCount / UL_PAGE_LEN, ulReadByteRemain = ulCount % UL_PAGE_LEN;
	DWORD ulPageIndex = 0;
	BYTE ucSlaveAddress = g_pcpRsComm->GetIspSlave();

	if(g_pcpRsComm->GetCommID() == _ENUM_COMM_TYPECUSB)
	{
		DWORD ulFlashAddr = (DWORD)(usBankAddr << 16) | ulStartAddr;
		enumError = g_pcpRsComm->ReadFlashData(ulFlashAddr, (WORD)ulCount, pucBuff);
		IF_ERROR_THEN_RETURN(enumError);
		return _ERROR_SUCCESS;
	}
	// The read first byte is wrong, so draw back 1 byte
	--ulStartAddr;
	if(ulStartAddr == 0xFFFFFFFF)
	{
		--usBankAddr;
	}
	// Read code
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x46);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x03);
	IF_ERROR_THEN_RETURN(enumError);

	// Address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, (BYTE)(usBankAddr & 0x00FF));
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, (BYTE)((ulStartAddr & 0x0000FF00) >> 8));
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, (BYTE)(ulStartAddr & 0x000000FF));
	IF_ERROR_THEN_RETURN(enumError);

	// op code
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_6A, 0x03);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x47);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 200);
	IF_ERROR_THEN_RETURN(enumError);

	// Read to buff
	enumError = g_pcpRsComm->I2CReadEx(ucSlaveAddress, _MCUREG_70, 1, (BYTE *)(&ulPageIndex), _INCTYPE_NONE);
	IF_ERROR_THEN_RETURN(enumError);

	for(ulPageIndex = 0; ulPageIndex < ulReadPageCount; ++ulPageIndex)
	{
		enumError = g_pcpRsComm->I2CReadEx(ucSlaveAddress, _MCUREG_70, (WORD)UL_PAGE_LEN, pucBuff + UL_PAGE_LEN * ulPageIndex, _INCTYPE_NONE);
		IF_ERROR_THEN_RETURN(enumError);
	}

	// Read bytes remain
	if(ulReadByteRemain != 0)
	{
		enumError = g_pcpRsComm->I2CReadEx(ucSlaveAddress, _MCUREG_70, (WORD)ulReadByteRemain, pucBuff + UL_PAGE_LEN * ulPageIndex, _INCTYPE_NONE);
		IF_ERROR_THEN_RETURN(enumError);
	}

	return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE ClearBootFlag(DWORD ulAddr, DWORD ulFlagLenth, BYTE *pucFlag, CCpFlash *pcpFlash)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	INT nActualFlagLen = UL_BOOT_FLAG_COUNT, i = 0;
	BYTE ucBankIndex = (ulAddr >> 16) & 0xFF;
	BYTE ucszReadByte[UL_BOOT_FLAG_COUNT] = { 0 };
	BYTE ucszByteBuff[UL_SECTOR_LEN] = { 0 };

	// Get actual len of flag
	nActualFlagLen = GetValidLength(pucFlag, ulFlagLenth);

	// Read data to judge if need clear flag
	enumError = ReadFlashData(ucBankIndex, ulAddr, nActualFlagLen, ucszReadByte);
	IF_ERROR_THEN_RETURN(enumError);

	for(i = 0; i < nActualFlagLen; ++i)
	{
		if(ucszReadByte[i] != 0xFF)
		{
			break;
		}
	}
	if(i == nActualFlagLen)
	{
		return _ERROR_SUCCESS;
	}
	// Clear flag, read the sector first
	memset(ucszByteBuff, 0xFF, UL_SECTOR_LEN);
	enumError = ReadFlashData(ucBankIndex, ulAddr & 0xFFF000, UL_SECTOR_LEN, ucszByteBuff);
	IF_ERROR_THEN_RETURN(enumError);
	// The address where store flag set to 0xFF
	for(i = 0; i < nActualFlagLen; ++i)
	{
		*(ucszByteBuff + (ulAddr & 0xFFF) + i) = 0xFF;
	}

	enumError = SectorErase(ucBankIndex, (ulAddr >> 12) & 0x0F, pcpFlash);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = WriteDataToFlash(ulAddr & 0xFFF000, UL_SECTOR_LEN, ucszByteBuff, pcpFlash);

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE WriteDataToFlashByTypeCUsb(DWORD ulDesAddr, DWORD ulProLen, BYTE *pucBuff, CCpFlash *pcpFlash)
{
	WORD usPageCount = (WORD)(ulProLen / UL_PAGE_LEN), usPageIndex = 0, i = 0;
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	BYTE *pucBuffTmp = NULL;
	DWORD ulFlashAddr = 0;
	BYTE ucPageReadBuf[UL_PAGE_LEN] = { 0 };
	BOOL bEnableSWREN = FALSE;
	BOOL bEnableSWRENEveryPage = FALSE;
	BYTE ucszDWPSR[4] = { 0 };
	WORD usRemainDataLen = (WORD)(ulProLen % UL_PAGE_LEN);
	WORD usWriteLen = UL_PAGE_LEN;

	if(usRemainDataLen != 0)
	{
		++usPageCount;
	}

	if(usPageCount == 0)
	{
		return _ERROR_SUCCESS;
	}

	// Op code for  FW Flash Port Access methond isp. 
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_6D, 0x02);
	IF_ERROR_THEN_RETURN(enumError);

	// Write page circularly
	for(usPageIndex = 0; usPageIndex < usPageCount; ++usPageIndex)
	{
		if(usPageIndex == (usPageCount - 1))
		{
			if(usRemainDataLen != 0)
			{
				usWriteLen = usRemainDataLen;
			}
		}
		// If this page is all 0xFF, skip
		pucBuffTmp = pucBuff + UL_PAGE_LEN * usPageIndex;
		for(i = 0; i < usWriteLen; ++i)
		{
			if(*(pucBuffTmp + i) != 0xFF)
			{
				break;
			}
		}
		if(i == usWriteLen)
		{
			continue;
		}

		// If has SWREN, should Disable WP every page, such as MX25L2026CM1
		bEnableSWREN = pcpFlash->GetEnableSWREN();
		bEnableSWRENEveryPage = pcpFlash->GetSendSWRENEveryPage();
		if(bEnableSWREN && bEnableSWRENEveryPage)
		{
			pcpFlash->GetDWPSR(ucszDWPSR);
			enumError = WriteFlashSR(ucszDWPSR, pcpFlash);
			IF_ERROR_THEN_RETURN(enumError);
		}

		ulFlashAddr = ulDesAddr + usPageIndex * UL_PAGE_LEN;
		enumError = g_pcpRsComm->WriteFlashData(ulFlashAddr, usWriteLen, pucBuffTmp);
		IF_ERROR_THEN_RETURN(enumError);

		memset(ucPageReadBuf, 0x00, UL_PAGE_LEN);
		enumError = g_pcpRsComm->ReadFlashData(ulFlashAddr, usWriteLen, ucPageReadBuf);
		IF_ERROR_THEN_RETURN(enumError);

		if(memcmp(pucBuffTmp, ucPageReadBuf, usWriteLen) != 0)
		{
			return _ERROR_PLUGIN_ISP_CHECK_DATA_FAIL;
		}

		g_cpIspProgress.StepIt();
	}
	return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE WriteDataToFlash(DWORD ulDesAddr, DWORD ulProLen, BYTE *pucBuff, CCpFlash *pcpFlash)
{
	WORD usPageCount = (WORD)(ulProLen / UL_PAGE_LEN), usPageIndex = 0, i = 0;
	BYTE ucCalculatePageCRC = 0, ucReadPageCRC = 0, ucBankIndex = (ulDesAddr >> 16) & 0xFF;
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	BYTE ucSlaveAddr = UC_SLAVE_ADDR;
	BYTE ucDesPageStart = (ulDesAddr >> 8) & 0xFF, *pucBuffTmp = NULL;
	BYTE ucszDWPSR[4] = { 0 };
	WORD usWriteLen = UL_PAGE_LEN;
	WORD usRemainDataLen = (WORD)(ulProLen % UL_PAGE_LEN);
	string strResultPath;

	ucSlaveAddr = g_pcpRsComm->GetIspSlave();
	if(g_pcpRsComm->GetCommID() == _ENUM_COMM_TYPECUSB)
	{
		return WriteDataToFlashByTypeCUsb(ulDesAddr, ulProLen, pucBuff, pcpFlash);
	}
	if((usRemainDataLen) != 0)
	{
		++usPageCount;
	}

	if(usPageCount == 0)
	{
		return _ERROR_SUCCESS;
	}

	// Op code
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_6D, 0x02);
	IF_ERROR_THEN_RETURN(enumError);

	// Send Len
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_71, (BYTE)(UL_PAGE_LEN - 1));
	IF_ERROR_THEN_RETURN(enumError);

	// Byte address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, ulDesAddr & 0xFF);
	IF_ERROR_THEN_RETURN(enumError);

	// Write page circularly
	for(usPageIndex = 0; usPageIndex < usPageCount; ++usPageIndex)
	{
		if(usPageIndex == (usPageCount - 1))
		{
			if(usRemainDataLen != 0)
			{
				// change Len
				usWriteLen = usRemainDataLen;
				enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_71, (BYTE)(usWriteLen - 1));
				IF_ERROR_THEN_RETURN(enumError);
			}
		}
		// If this page is all 0xFF, skip
		pucBuffTmp = pucBuff + UL_PAGE_LEN * usPageIndex;
		for(i = 0; i < usWriteLen; ++i)
		{
			if(*(pucBuffTmp + i) != 0xFF)
			{
				break;
			}
		}
		if(i == usWriteLen)
		{
			continue;
		}

		// If has SWREN, should DWP every page, such as MX25L2026CM1
		if(pcpFlash->GetEnableSWREN() && pcpFlash->GetSendSWRENEveryPage())
		{
			pcpFlash->GetDWPSR(ucszDWPSR);
			enumError = WriteFlashSR(ucszDWPSR, pcpFlash);
			IF_ERROR_THEN_RETURN(enumError);
		}

		// Bank index
		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, ucBankIndex);
		IF_ERROR_THEN_RETURN(enumError);

		// Page index
		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, (BYTE)(ucDesPageStart + usPageIndex));
		IF_ERROR_THEN_RETURN(enumError);

		// Wait to can write data
		enumError = WaitForBitChange(_MCUREG_6F, _BIT4, _BIT4, 600);
		IF_ERROR_THEN_RETURN(enumError);

		// Send bin buff address
		enumError = g_pcpRsComm->I2CWriteEx(ucSlaveAddr, _MCUREG_70, usWriteLen, pucBuffTmp, _INCTYPE_NONE);
		IF_ERROR_THEN_RETURN(enumError);
		// Start prog
		enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_6F, 0xFF, _BIT5);
		IF_ERROR_THEN_RETURN(enumError);

		// Wait finish
		enumError = WaitForBitChange(_MCUREG_6F, _BIT5, 0, 600);
		IF_ERROR_THEN_RETURN(enumError);

		// Read CRC and check
		if(usPageIndex == 0)
		{
			ucCalculatePageCRC = CalculateByteCRC(pucBuff, usWriteLen);
			enumError = ReadCRC(ucBankIndex, (WORD)ulDesAddr, usWriteLen, &ucReadPageCRC);
			IF_ERROR_THEN_RETURN(enumError);

			if(ucReadPageCRC != ucCalculatePageCRC)
			{
				return _ERROR_PLUGIN_ISP_WRITE_FIRST_PAGE_ERROR;
			}
		}

		g_cpIspProgress.StepIt();
		strResultPath.assign(g_cpstrPath.begin(), g_cpstrPath.end());
		g_cpIspProgress.ReocordISPResult(strResultPath, g_cpIspProgress.GetCurrentProgress());

	}

	// Check the whole CRC
	ucCalculatePageCRC = CalculateByteCRC(pucBuff, ulProLen);
	enumError = ReadCRC(ucBankIndex, (WORD)ulDesAddr, ulProLen, &ucReadPageCRC);
	IF_ERROR_THEN_RETURN(enumError);

	if(ucReadPageCRC != ucCalculatePageCRC)
	{
		return _ERROR_PLUGIN_ISP_CRC_DIFFERENT_ISP_FAIL;
	}

	return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE WriteBootFlag(DWORD ulAddr, DWORD ulFlagLength, BYTE *pucFlag, CCpFlash *pcpFlash)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	DWORD ulActualFlagLen = UL_BOOT_FLAG_COUNT;
	CCpRsString strLog;

	// Get actual len of flag
	ulActualFlagLen = GetValidLength(pucFlag, ulFlagLength);
	
	enumError = WriteDataToFlash(ulAddr, ulActualFlagLen, pucFlag, pcpFlash);
	if(enumError != _ERROR_SUCCESS)
	{
		strLog.Format(_T(" WriteDataToFlash Fail! , Error Code:0x%x"), enumError);
		LogRecord(strLog);
		return enumError;
	}

	return enumError;

}

void LoadFlashData(std::map<string, CCpFlash> &mapFlashInfo, CCpRsString cpstrPath)
{
	CCpFlashDat cpFlashDat;
	string strWorkPath;
	string strExePath;
    
	strExePath.assign(cpstrPath.begin(), cpstrPath.end());
	strWorkPath = GetFlashDatPathPlusName(strExePath);

	cpFlashDat.LoadFlashDat(strWorkPath, mapFlashInfo);
}

// Just called by GetFlashType()
STRUCT_ENUM_ERROR_TYPE ReadFlashIDCode(ENUM_FLASH_IDCODE_TYPE enumFlashIDCodeType, BYTE* pucIDCode)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	BYTE ucTemp[2] = { 0 };

	if(_ENUM_FLASH_IDCODE_TYPE_9FAB == enumFlashIDCodeType)
	{
		// Write 9F, get 3 bytes back
		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x46);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x9F);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x47);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 600);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_67, &pucIDCode[0]);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_68, &pucIDCode[1]);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_69, &pucIDCode[2]);
		IF_ERROR_THEN_RETURN(enumError);

		// Send AB, get the other byte
		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x5A);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0xAB);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, 0x00);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x5B);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 600);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_67, &pucIDCode[3]);
		IF_ERROR_THEN_RETURN(enumError);
	}
	else if(_ENUM_FLASH_IDCODE_TYPE_9F90 == enumFlashIDCodeType)
	{
		// Write 9F, get 3 bytes back
		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x46);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x9F);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x47);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 600);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_67, &pucIDCode[0]);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_68, &pucIDCode[1]);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_69, &pucIDCode[2]);
		IF_ERROR_THEN_RETURN(enumError);

		// Send 90, get the other byte
		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x5C);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x90);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, 0x00);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x5D);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 600);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_67, &ucTemp[0]);
		IF_ERROR_THEN_RETURN(enumError);

		enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_68, &ucTemp[1]);
		IF_ERROR_THEN_RETURN(enumError);

		pucIDCode[3] = ucTemp[1];
	}
	// Add other IDCode type
	/*else if(type2 == enumFlashIDCodeType)
	{

	}*/

	return enumError;
}


STRUCT_ENUM_ERROR_TYPE GetFlashType(std::map<string, CCpFlash> &mapFlashInfo, CCpFlash &cpFlash)
{
	BYTE ucszData[UL_IDCODE_LEN] = { 0 };
	INT nIDTypeIndex = 0;
	CCpFlashDat cpFlashDat;
	BOOL bResult = FALSE;
	string strFlashName;
	std::map<string, CCpFlash>::iterator it;
	ENUM_SPECIFY_FLASH_MISMATCH_DETECTED enumSpecifyFlash = _ENUM_SPECIFIED_ONE;
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

	// Find the right type flash, and put it to m_stCurFlashType
	for(nIDTypeIndex = _ENUM_FLASH_IDCODE_TYPE_START; nIDTypeIndex < _ENUM_FLASH_IDCODE_TYPE_END; ++nIDTypeIndex)
	{
		// Read IDCode to ucszData
		enumError = ReadFlashIDCode((ENUM_FLASH_IDCODE_TYPE)nIDTypeIndex, ucszData);

		if(enumError == _ERROR_COMMONFUNC_POLLINGFAIL)
		{
			continue;
		}

		// Auto detect flash
		if(g_pcpIspSetting->GetAutoDetectFlash())
		{
			bResult = cpFlashDat.GetFlashInfoByIDCode(ucszData, mapFlashInfo, cpFlash);

			if(bResult)
			{
				return _ERROR_SUCCESS;
			}
			else
			{
				continue;
			}
		}
		// User has specified a flash type name
		else
		{
			enumSpecifyFlash = g_pcpIspSetting->GetFlashMismatch();

			bResult = cpFlashDat.GetFlashInfoByIDCode(ucszData, mapFlashInfo, cpFlash);

			if(bResult)
			{
				if(g_pcpIspSetting->GetSpecifiedFlashName() == cpFlash.GetFlashName())
				{
					return _ERROR_SUCCESS;
				}
			}
			else
			{
				return _ERROR_PLUGIN_ISP_NOT_FIND_SPECIFIED_FLASH_INFO;
			}

			if(_ENUM_SPECIFIED_ONE == enumSpecifyFlash)
			{

				strFlashName = g_pcpIspSetting->GetSpecifiedFlashName();

				if(strFlashName.empty())
				{
					return _ERROR_PLUGIN_ISP_SPECIFIED_FLASH_NAME_EMPTY;
				}

				bResult = cpFlashDat.GetFlashInfoByFlashName(strFlashName, mapFlashInfo, cpFlash);

				if(bResult)
				{
					return _ERROR_SUCCESS;
				}
				else
				{
					return _ERROR_PLUGIN_ISP_NOT_FIND_SPECIFIED_FLASH_INFO;
				}

			}
			else if(_ENUM_DETECTED_ONE == enumSpecifyFlash)
			{
				bResult = cpFlashDat.GetFlashInfoByIDCode(ucszData, mapFlashInfo, cpFlash);

				if(bResult)
				{
					return _ERROR_SUCCESS;
				}
			}
			else
			{
				// Cancel to quit 
				return _ERROR_PLUGIN_ISP_CANCEL;
			}
		}

	}


	// Find no flash, so use default value
	if((ENUM_FLASH_IDCODE_TYPE)nIDTypeIndex == _ENUM_FLASH_IDCODE_TYPE_END)
	{
		// strFlashName = STR_FLASH_NAME_DEFAULT;

		strFlashName = STR_FLASH_NAME_DEFAULT;
		bResult = cpFlashDat.GetFlashInfoByFlashName(strFlashName, mapFlashInfo, cpFlash);

		if(bResult)
		{
			return _ERROR_PLUGIN_ISP_FLASH_MISMATCH_USE_DEFAULT_VALUE;
		}
		else
		{
			return _ERROR_PLUGIN_ISP_CANCEL;
		}
	}

	return _ERROR_PLUGIN_ISP_CANCEL;
}

STRUCT_ENUM_ERROR_TYPE SetI2CSpeed(WORD usSpeed)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	enumError = g_pcpRsComm->SetI2CSpeed(usSpeed);
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE GD25M21BReadSecurityShieldReg(BYTE *pucRead)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	INT nRegIndex = 0;

	for(nRegIndex = 0; nRegIndex < N_GD25M21B_SECURITY_REG_COUNT; ++nRegIndex)
	{
		enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x5A);
		IF_ERROR_THEN_RETURN(enumError);
		g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x4E);
		g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
		g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
		g_pcpRsComm->WriteMcuReg(_MCUREG_66, (BYTE)nRegIndex);
		g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x5B);
		enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 200);
		IF_ERROR_THEN_RETURN(enumError);
		g_pcpRsComm->ReadMcuReg(_MCUREG_67, pucRead + nRegIndex);
	}
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE GD25M21BProgramSecurityShieldReg(BYTE *pucRead)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	BYTE ucData = 0, ucszBuf[20] = { 0 };

	//////////////////////////////////////////////////////////////////////////
	// Read 0x000000 data in flash
	//////////////////////////////////////////////////////////////////////////
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x5A);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x03);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x5B);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = WaitForBitChange(_MCUREG_60, _BIT0, 0, 200);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->ReadMcuReg(_MCUREG_67, &ucData);
	IF_ERROR_THEN_RETURN(enumError);

	//////////////////////////////////////////////////////////////////////////
	// Program security shield register
	//////////////////////////////////////////////////////////////////////////
	// Command 0x96 + 24-bit address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x38);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x96);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, 0x10);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x39);
	IF_ERROR_THEN_RETURN(enumError);

	// Command 0xDD + 24-bit address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x38);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0xDD);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, 0x10);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x39);
	IF_ERROR_THEN_RETURN(enumError);

	// Command 0x3F + 24-bit address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x38);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x3F);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, 0x10);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x39);
	IF_ERROR_THEN_RETURN(enumError);

	// Command 0x96 + 24-bit address
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x38);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_61, 0x96);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, 0x10);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_60, 0x39);
	IF_ERROR_THEN_RETURN(enumError);

	//////////////////////////////////////////////////////////////////////////
	// Command 0x47 + 24-bit address + 8 bytes data
	//////////////////////////////////////////////////////////////////////////
	// DDC channel enable and set ddc_addr = 'b111
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_1B, 0x1A, 0xE5);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_1E, 0x1A, 0xE5);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_2C, 0x1A, 0xE5);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE64, 0x1A, 0xE5);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE6D, 0x1A, 0xE5);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE76, 0x1A, 0xE5);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE7F, 0x1A, 0xE5);
	IF_ERROR_THEN_RETURN(enumError);
	// DDC force ack
	//if(enumScaler == _SCALER_RL6001)
	//{
	//	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_02, 0xDF, 0x00);
	//	IF_ERROR_THEN_RETURN(enumError);
	//}
	//else
	//{
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_E7, 0xDF, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	//}
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_E4, 0xDF, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_E5, 0xDF, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE69, 0xDF, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE72, 0xDF, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE7B, 0xDF, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteRegBitEx(_REG_FE84, 0xDF, 0x00);
	IF_ERROR_THEN_RETURN(enumError);

	// Force ddc ram start and allow ddc2b access in isp mode
	//if(bNewIC)
	//{
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_E9, 0x9F, 0x60);
	//}
	//else
	//{
	//	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_21, 0x3F, 0xC0);
	//}
	IF_ERROR_THEN_RETURN(enumError);

	// Write data to buffer
	ucszBuf[0] = 0x0D;
	ucszBuf[1] = 0x00;
	ucszBuf[2] = 0x47;
	ucszBuf[3] = 0x00;
	ucszBuf[4] = 0x00;
	ucszBuf[5] = 0x00;
	memcpy(ucszBuf + 6, pucRead, N_GD25M21B_SECURITY_REG_COUNT);
	ucszBuf[14] = 0x00;
	enumError = g_pcpRsComm->I2CWriteEx(0xAE, 0x00, 0x0F, ucszBuf, _INCTYPE_AUTO);
	IF_ERROR_THEN_RETURN(enumError);

	// Disable force ddc ram start and allow ddc2b access in isp mode
	//if(bNewIC)
	//{
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_E9, 0x9F, 0x00);
	//}
	//else
	//{
	//	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_21, 0x3F, 0x00);
	//}
	IF_ERROR_THEN_RETURN(enumError);
	// Set isp CMD length
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_82, 0x0E);
	IF_ERROR_THEN_RETURN(enumError);
	// Enable insert CMD before isp program
	enumError = g_pcpRsComm->WriteMcuRegBit(_MCUREG_81, 0xFE, 0x01);
	IF_ERROR_THEN_RETURN(enumError);
	// Write 0x000000
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_64, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_65, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_66, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_71, 0x00);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_70, ucData);
	IF_ERROR_THEN_RETURN(enumError);
	enumError = g_pcpRsComm->WriteMcuReg(_MCUREG_6F, 0xA0);
	IF_ERROR_THEN_RETURN(enumError);

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE RunSafeGuardCmd(CCpFlash &cpFlash, BOOL bEnableWP)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	string strFlashName;
	BYTE *pucSGCmd = NULL;
	BYTE *pucSGCmdTemp = NULL;
	BOOL bResult = false;
	BYTE ucSGRegCount = 0;
	WORD usBankCount = 0;
	DWORD ulLength = 0;
	BYTE i = 0;
	string strSGCmd;
	CCpFlashDat cpFlashDat;
    BYTE ucValue = 0;

	strFlashName = cpFlash.GetFlashName();
	usBankCount = cpFlash.GetBankCount();

	if(cpFlash.GetEnableSafeGuard())
	{
		if(bEnableWP)
		{
			ucValue = 0;
			strSGCmd = cpFlash.GetEnableSafeGuardCmd();
		}
		else
		{
			ucValue = 0xff;
			strSGCmd = cpFlash.GetDisableSafeGuardCmd();
		}

		if(strFlashName.compare(STR_FLASH_NAME_PM25LD020) == 0)
		{
			ucSGRegCount = N_PM25LD020_SAFE_GUARD_REG_COUNT;
		}
		else if(strFlashName.compare(STR_FLASH_NAME_PM25LQ080) == 0)
		{
			ucSGRegCount = (BYTE)usBankCount;
		}
		else if(strFlashName.compare(STR_FLASH_NAME_PM25LQ016) == 0)
		{
			ucSGRegCount = (BYTE)usBankCount + 1;
		}
		else
		{
			ucSGRegCount = (BYTE)usBankCount * 2;
		}

		ulLength = (DWORD)strSGCmd.length() / 3;
		pucSGCmd = new BYTE[ulLength];
		pucSGCmdTemp = new BYTE[ulLength];
		memset(pucSGCmd, 0, ulLength);
		memset(pucSGCmdTemp, 0, ulLength);

		bResult = cpFlashDat.StringCmdToByte(strSGCmd, pucSGCmd, ulLength);
		if(!bResult)
		{
			SAFELY_DELETE(pucSGCmd);
			SAFELY_DELETE(pucSGCmdTemp);
			return _ERROR_PLUGIN_ISP_CMD_STRING_TO_BYTE;
		}
		for(i = 0; i < ucSGRegCount; i++)
		{
			memcpy(pucSGCmdTemp, pucSGCmd, ulLength);
			// Replace 0xEE with SGRegCount
			cpFlashDat.ReplaceByte(0xEE, i, pucSGCmdTemp, ulLength);
			enumError = RunCommand(pucSGCmdTemp, ulLength, g_pcpRsComm, NULL);
			if(enumError != _ERROR_SUCCESS)
			{
				SAFELY_DELETE(pucSGCmd);
				SAFELY_DELETE(pucSGCmdTemp);
				return enumError;
			}
		}
	}

	SAFELY_DELETE(pucSGCmd);
	SAFELY_DELETE(pucSGCmdTemp);
	return enumError;
}

// Load one bank fw
STRUCT_ENUM_ERROR_TYPE LoadFWBank(string strFwPath, DWORD ulBankNum, BYTE *pucBuff)
{
	CHAR cszCurrentDir[MAX_DIR_LENGTH] = { 0 };
	DWORD ulFilePos = 0;

	strncpy(cszCurrentDir, strFwPath.c_str(), sizeof(cszCurrentDir));

	ifstream fileFlashDat(cszCurrentDir, ios::in | ios::binary);
	if(fileFlashDat.is_open())
	{
		ulFilePos = ulBankNum * UL_MAX_SERIALBANK_LENGTH;
		fileFlashDat.seekg(ulFilePos);
		fileFlashDat.read((CHAR *)pucBuff, UL_MAX_SERIALBANK_LENGTH);
		return _ERROR_SUCCESS;
	}

	return _ERROR_PLUGIN_ISP_LOAD_ONE_BANK_FW;
}

//ulBankIndex Flash's BankNum 
STRUCT_ENUM_ERROR_TYPE GetFinalCode(DWORD ulBankIndex, STRUCT_FW_BANK_SETTING stFwBankSetting, BYTE *pucBuff, DWORD *pulProlen, BOOL *pbSectorErase, DWORD *pulSectorEraseCount, std::map<DWORD, STRUCT_RESERVE_ITEM> mapReserveItem)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	std::map<DWORD, STRUCT_RESERVE_ITEM>::iterator itReserveItem;
	vector<STRUCT_RESERVE_ITEM> stReserveItemVec;
	CCpRsString strLog;
	DWORD ulSize = 0;
	DWORD ulFlashLen = 0;

	*pbSectorErase = FALSE;
	*pulSectorEraseCount = 0;

	enumError = LoadFWBank(stFwBankSetting.strFwPath, stFwBankSetting.ulFwBank, pucBuff);
	if(_ERROR_SUCCESS != enumError)
	{
		strLog.Format(_T(" Load Bank %d FW Fail! "), ulBankIndex);
		LogRecord(strLog);
		return enumError;
	}

	// Reserve Setting
	for(itReserveItem = mapReserveItem.begin(); itReserveItem != mapReserveItem.end(); ++itReserveItem)
	{
		if(ulBankIndex == itReserveItem->second.ucBankIndex)
		{
			stReserveItemVec.push_back(itReserveItem->second);
		}
	}

	if(stReserveItemVec.empty())
	{
		*pulProlen = GetValidLength(pucBuff, UL_MAX_SERIALBANK_LENGTH);
		return _ERROR_SUCCESS;
	}

	for(ulSize = 0; ulSize < stReserveItemVec.size(); ++ulSize)
	{
		if(itReserveItem->second.bSave)
		{
			enumError = ReadFlashData((WORD)ulBankIndex,
				itReserveItem->second.usStartAddr,
				itReserveItem->second.ulLen,
				pucBuff + itReserveItem->second.usStartAddr);
			if(_ERROR_SUCCESS != enumError)
			{
				g_strLog.Format(_T("Read flash data fail! Error code: 0x%X"), enumError);
				LogRecord(g_strLog);
				return enumError;
			}
			*pulProlen = GetValidLength(pucBuff, UL_MAX_SERIALBANK_LENGTH);
		}
		else
		{
			if(itReserveItem->second.bAuto)
			{
				*pbSectorErase = TRUE;

				*pulProlen = GetValidLength(pucBuff, UL_MAX_SERIALBANK_LENGTH);

				// Sector Erase  Sector 0 to Sector(*pulSectorEraseCount - 1)
				if((*pulProlen) % UL_SECTOR_LEN == 0)
				{
					*pulSectorEraseCount = *pulProlen / UL_SECTOR_LEN + 1;
				}
				else
				{
					*pulSectorEraseCount = *pulProlen / UL_SECTOR_LEN + 2;
				}
			}
			else if(itReserveItem->second.ucEraseSectorCount != SECTOR_INDEX_INVALID)
			{
				*pbSectorErase = TRUE;
				if(itReserveItem->second.ucEraseSectorCount > *pulSectorEraseCount)
				{
					*pulSectorEraseCount = itReserveItem->second.ucEraseSectorCount;
				}

				ulFlashLen = itReserveItem->second.ucEraseSectorCount * UL_SECTOR_LEN;

				if(ulFlashLen > *pulProlen)
				{
					*pulProlen = ulFlashLen;
				}
			}

		}
	}

	return _ERROR_SUCCESS;
}

DWORD GetValidLength(BYTE *pucBuff, DWORD ulBuffLength)
{
	DWORD ulLength = 0;
	for(ulLength = ulBuffLength - 1; ulLength < ulBuffLength; --ulLength)
	{
		if(0xFF != pucBuff[ulLength])
		{
			break;
		}
	}
	return (++ulLength);
}

STRUCT_ENUM_ERROR_TYPE EnableSoftWareWP(CCpFlash &cpFlash, BYTE *pucszReadGD25M21BSecurityRegs)
{
	BYTE ucszEWPSR[UL_SR_MAX_COUNT] = { 0 };
	CCpRsString strLog;
	string strFlashName;
	STRUCT_ENUM_ERROR_TYPE enumError;

	strFlashName = cpFlash.GetFlashName();
	cpFlash.GetEWPSR(ucszEWPSR);
	enumError = WriteFlashSR(ucszEWPSR, &cpFlash);
	if(_ERROR_SUCCESS != enumError)
	{
		g_strLog.Format(_T("Write flash SR fail. Error code:0x%X"), enumError);
		LogRecord(strLog);
		return enumError;
	}

	// Special Flash
	// If it is GD25M21B, then program the security shield regs
	if((strFlashName.compare(STR_FLASH_NAME_GD25M21B) == 0)
		|| (strFlashName.compare(STR_FLASH_NAME_GD25M41B) == 0))
	{
		enumError = GD25M21BProgramSecurityShieldReg(pucszReadGD25M21BSecurityRegs);
		if(_ERROR_SUCCESS != enumError)
		{
			strLog.Format(_T("Read GD25M21_B security shield register fail. Error code: 0x%X"), enumError);
			LogRecord(strLog);
			return enumError;
		}
	}
	// SaftGuard Enable WP
	enumError = RunSafeGuardCmd(cpFlash, true);
	if(_ERROR_SUCCESS != enumError)
	{
		strLog.Format(_T("Enable WP RunSafeGuardCmd Fail, Error code: 0x%X"), enumError);
		LogRecord(strLog);
		return enumError;
	}

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE DisableSoftWareWP(CCpFlash &cpFlash, BYTE *pucszReadGD25M21BSecurityRegs)
{
	CCpRsString strLog;
	string strFlashName;
	BOOL bEnableWP = FALSE;
	BYTE ucszDWPSR[UL_SR_MAX_COUNT] = { 0 };

	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

	strFlashName = cpFlash.GetFlashName();

	// Deal With Specail Flash
	strLog.Format(_T("---Deal with Specail Flash Begin---"));
	LogRecord(strLog);

	// If it is GD25M21B, then read the security shield regs
	if((strFlashName.compare(STR_FLASH_NAME_GD25M21B) == 0)
		|| (strFlashName.compare(STR_FLASH_NAME_GD25M41B) == 0))
	{
		enumError = GD25M21BReadSecurityShieldReg(pucszReadGD25M21BSecurityRegs);
		if(_ERROR_SUCCESS != enumError)
		{
			strLog.Format(_T("Read GD25M21_B security shield register fail. Error code: 0x%X"), enumError);
			LogRecord(strLog);
			return enumError;
		}
	}

	// Disable WP
	enumError = RunSafeGuardCmd(cpFlash, bEnableWP);
	if(_ERROR_SUCCESS != enumError)
	{
		strLog.Format(_T("Disable WP RunSafeGuardCmd Fail, Error code: 0x%X"), enumError);
		LogRecord(strLog);
		return enumError;
	}

	// If the flash has no SWREN , Disable WP
	if(!cpFlash.GetEnableSWREN())
	{
		cpFlash.GetDWPSR(ucszDWPSR);
		enumError = WriteFlashSR(ucszDWPSR, &cpFlash);
		if(_ERROR_SUCCESS != enumError)
		{
			strLog.Format(_T("Write flash SR fail. Error code:0x%X"), enumError);
			LogRecord(strLog);
			return enumError;
		}
	}
	return enumError;
}


// Write Flag 0x55 
STRUCT_ENUM_ERROR_TYPE WriteExtraBootFlag(CCpFlash &cpFlash)
{
	BYTE ucFlag = 0x55;
	CCpRsString strLog;
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

	enumError = ClearBootFlag((g_pcpIspSetting->GetBootFlag().ulAddr + 4), 1, &ucFlag, &cpFlash);
	if(_ERROR_SUCCESS != enumError)
	{
		strLog.Format(_T(" ClearBootFlag Fail! "));
		LogRecord(strLog);
		return enumError;
	}

	ucFlag = 0x55;
	enumError = WriteBootFlag((g_pcpIspSetting->GetBootFlag().ulAddr + 4), 1, &ucFlag, &cpFlash);
	if(_ERROR_SUCCESS != enumError)
	{
		strLog.Format(_T(" WriteBootFlag Fail! "));
		LogRecord(strLog);
		return enumError;
	}

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE EraseOperation(CCpFlash &cpFlash, BYTE *pucszReadGD25M21BSecurityRegs, std::map<DWORD, STRUCT_RESERVE_ITEM> mapReservedItem)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	DWORD i = 0;

	if(_ENUM_FLASH_CHIP_ERASE == g_pcpIspSetting->GetEraseType() || _ENUM_FLASH_BANK_ERASE == g_pcpIspSetting->GetEraseType())
	{
		if(_ENUM_FLASH_CHIP_ERASE == g_pcpIspSetting->GetEraseType())
		{
			// reserve  function type
			if(mapReservedItem.empty())
			{
				if(FUNCTYPE_ENABLE_CHIP_ERASE(g_pcpIspSetting->GetIspFunctionType()))
				{
					enumError = ChipErase(&cpFlash);
					IF_ERROR_THEN_RETURN(enumError);
				}
				else
				{
					g_pcpIspSetting->SetEraseType(_ENUM_FLASH_BANK_ERASE);
				}
			}
			else
			{
				if(_ENUM_FUNC_ERASE == g_pcpIspSetting->GetIspFunctionType())
				{
					return _ERROR_PLUGIN_ISP_ONLY_CHIP_ERASE_HAVE_RESERVE_SETTING;
				}
				else
				{
					g_pcpIspSetting->SetEraseType(_ENUM_FLASH_BANK_ERASE);
				}
			}
		}

		if(_ENUM_FUNC_ERASE == g_pcpIspSetting->GetIspFunctionType())
		{
			if(_ENUM_FLASH_BANK_ERASE == g_pcpIspSetting->GetEraseType())
			{
				for(i = 0; i < cpFlash.GetBankCount(); i++)
				{
					// Check If the bank has Reserve Setting
					enumError = BankErase(i, &cpFlash);
				}
			}
			// Enable WP
			enumError = EnableSoftWareWP(cpFlash, pucszReadGD25M21BSecurityRegs);
			IF_ERROR_THEN_RETURN(enumError);

			ResetMcuAsSetting();

			return enumError;
		}
	}
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE CheckRomFlagOperation(BOOL bClearRomFlag, CCpFlash &cpFlash, STRUCT_ROM_FLAG_SETTING &stRomFlag)
{
	STRUCT_ENUM_ERROR_TYPE enumError;

	if(bClearRomFlag)
	{
		enumError = ClearBootFlag(stRomFlag.ulAddr, UL_BOOT_FLAG_COUNT, stRomFlag.ucszFlag, &cpFlash);
	}
	else
	{
		enumError = WriteBootFlag(stRomFlag.ulAddr, UL_BOOT_FLAG_COUNT, stRomFlag.ucszFlag, &cpFlash);
	}

	return enumError;
}

STRUCT_ENUM_ERROR_TYPE UserFlagOperation(BOOL bClearUserFlag, CCpFlash &cpFlash)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	STRUCT_BOOT_FLAG_SETTING stBootFlag;

	if(bClearUserFlag)
	{
		stBootFlag = g_pcpIspSetting->GetBootFlag();
		enumError  = ClearBootFlag(stBootFlag.ulAddr, UL_BOOT_FLAG_COUNT, stBootFlag.ucszFlag, &cpFlash);
	}
	else
	{
		stBootFlag = g_pcpIspSetting->GetBootFlag();
		enumError = WriteBootFlag(stBootFlag.ulAddr, UL_BOOT_FLAG_COUNT, stBootFlag.ucszFlag, &cpFlash);
	}
	
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadFWVersionFromFlash(STRUCT_READ_FW_VERSION *pstReadFwVersion)
{
	BYTE ucszTemp[3] = { 0 };
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

	// Read Project id and FW Version
	enumError = ReadFlashData(0, 0x7004, 3, ucszTemp);
	IF_ERROR_THEN_RETURN(enumError);
	pstReadFwVersion->usProjectID = (WORD)(((WORD)ucszTemp[0] << 2) + ((ucszTemp[1] & 0xC0) >> 6));
	pstReadFwVersion->ucFWVer = (BYTE)(ucszTemp[1] & 0x3F);
	pstReadFwVersion->ucFWSubVer = ucszTemp[2];
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE ReadFWVersionFromDDCCI(STRUCT_READ_FW_VERSION *pstReadFwVersion)
{
	return _ERROR_SUCCESS;
}

STRUCT_ENUM_ERROR_TYPE ReadFWVersionFromRegister(STRUCT_READ_FW_VERSION *pstReadFwVersion)
{
	BYTE ucVal0, ucVal1;
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	// 0x0003[7:0] + 0x0004[7:6] = Project ID
	// 0x0004[5:0] = FW Version
	// 0x0007[7:0] = FW Sub Version
	enumError = g_pcpRsComm->ReadRegEx(_REG_0003, &ucVal0);
	if(_ERROR_SUCCESS != enumError)
	{
		return enumError;
	}

	enumError = g_pcpRsComm->ReadRegEx(_REG_0004, &ucVal1);
	if(_ERROR_SUCCESS != enumError)
	{
		return enumError;
	}

	enumError = g_pcpRsComm->ReadRegEx(_REG_0007, &pstReadFwVersion->ucFWSubVer);
	if(_ERROR_SUCCESS != enumError)
	{
		return enumError;
	}
	pstReadFwVersion->usProjectID = (WORD)(((WORD)ucVal0 << 2) + ((ucVal1 & 0xC0) >> 6));
	pstReadFwVersion->ucFWVer = (BYTE)(ucVal1 & 0x3F);
	return enumError;
}

STRUCT_ENUM_ERROR_TYPE GetFWVersion(STRUCT_READ_FW_VERSION *pstReadFwVer)
{
	STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
	STRUCT_READ_VER_SETTING stReadVerSetting = g_pcpIspSetting->GetReadVerSetting();

	if(stReadVerSetting.bNeedRead)
	{
		g_pcpRsComm->ReleaseDev();
                
		g_pcpRsComm->SetDebugMode(_DEBUG_ISP);
		enumError = g_pcpRsComm->EnterIspMode(10);
		IF_ERROR_THEN_RETURN(enumError);
	
		switch(stReadVerSetting.enumType)
		{
		case _ENUM_VER_FROM_REG:
			enumError = ReadFWVersionFromRegister(pstReadFwVer);
			IF_ERROR_THEN_RETURN(enumError);
			break;
		case _ENUM_VER_FROM_DDCCI:
			enumError = ReadFWVersionFromDDCCI(pstReadFwVer);
			IF_ERROR_THEN_RETURN(enumError);
			break;
		case _ENUM_VER_FROM_FLASH:
			enumError = ReadFWVersionFromFlash(pstReadFwVer);
			IF_ERROR_THEN_RETURN(enumError);
			break;
		case _ENUM_VER_UNKNOWN:
			break;
		default:
			break;
		}

		ResetMcu();
		g_pcpRsComm->ReleaseDev();
	}

	return _ERROR_SUCCESS;
}

