#include "stdafx.h"
#include "CpIspFunc.h"
#include <time.h>
#include <unistd.h>

extern CCpRsString g_cpstrPath;
#define DLL_FILE_NAME_COMM "libComm.so"

void ShowMsg(CCpRsString str)
{
    cout << str << endl;
}

DWORD CpRsGetTickCount()
{
    struct timespec ts;
    clock_gettime(CLOCK_MONOTONIC, &ts);
    return (ts.tv_sec * 1000 + ts.tv_nsec / 1000000);
}

string GetFlashDatPathPlusName(string strPath)
{
	strPath += "/Flash.dat";
	return strPath;
}

string GetLogPathPlusName(string strLog)
{
	strLog += "/IspLog.txt";
	return strLog;
}

string GetSettingFilePath(string strCurDir)
{
    strCurDir += "/IspSetting.ini";

    return strCurDir;
}

STRUCT_ENUM_ERROR_TYPE CheckRsComm(STRUCT_CP_ISP_COMMAND_SETTING &stCmdSetting)
{
    static CCpRsComm cpRsComm;
    CCpRsString strDllName, strLog;
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;
    strDllName = g_cpstrPath + DLL_FILE_NAME_COMM;
    
    if(g_pcpRsComm != NULL)
    {
        return _ERROR_SUCCESS;
    }
    strLog.Format(_T("Set Comm Start"));
    LogRecord(strLog);
    g_pcpRsComm = &cpRsComm;
    
    g_pcpRsComm->LoadCommDllFile((TCHAR*)strDllName.c_str());
    g_pcpRsComm->Initiallize();
    if(g_pcpRsComm->GetCommCount() == 0)
    {
        strLog.Format(_T("No available communication type!"));
        LogRecord(strLog);
        return _ERROR_COMM_NOTEXIST;
    }
    if(stCmdSetting.enumCommID == _ENUM_COMM_UNKNOWN)
    {
        enumError = g_pcpRsComm->SetCommByID(_ENUM_COMM_USBHUBI2C);
    }
    else
    {
        enumError = g_pcpRsComm->SetCommByID(stCmdSetting.enumCommID);
    }
    strLog.Format(_T("Set Comm end"));

    return enumError;
}

