#pragma once
#include "../../Tool_Common/RsCommon/ErrorDefine.h"
#include "../../CpComm/Comm_Export/CpCommInclude.h"
#include "../../Tool_Common/RsDataType.h"
class CCpDeviceComBase
{
public:
    CCpDeviceComBase(void);
    virtual ~CCpDeviceComBase(void);

    virtual STRUCT_ENUM_ERROR_TYPE InitialDev() = 0;
    virtual STRUCT_ENUM_ERROR_TYPE ReleaseDev() = 0;
    virtual STRUCT_ENUM_COMM_ID GetCommID() = 0;
    virtual void GetCommName(TCHAR *pcName, WORD usLength) = 0;
    virtual WORD GetI2CPageLength();
    virtual WORD GetNativePageLength();
    virtual STRUCT_ENUM_ERROR_TYPE I2CWrite(BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE I2CRead(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE I2CWriteByte(BYTE ucSlave, BYTE ucSub, BYTE ucValue);
    virtual STRUCT_ENUM_ERROR_TYPE I2CCurrentRead(BYTE ucSlave, WORD usLength, BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE I2CWordWrite(BYTE ucSlave, WORD usSub, WORD usLength, const BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE I2CWordRead(BYTE ucSlave, WORD usSub, WORD usLength, BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE AdjustOption();
    virtual STRUCT_ENUM_ERROR_TYPE SetI2CSpeed(WORD usSpeed);
    virtual WORD GetI2CSpeed();
    virtual STRUCT_ENUM_ERROR_TYPE SetAuxMode(STRUCT_AUXMODE_STRUCT stAuxMode);
    virtual STRUCT_ENUM_ERROR_TYPE SetWaitingMode(STRUCT_WAITING_STRUCT stWaiting);
    virtual STRUCT_WAITING_STRUCT GetWaitingMode();
    virtual STRUCT_ENUM_ERROR_TYPE NativeWrite(INT nAddress, WORD usLength, const BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE NativeRead(INT nAddress, WORD usLength, BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE SetSettingFilePath(TCHAR *pcConfigFilePath);
    virtual void * GetDeviceHandler();
    virtual STRUCT_ENUM_ERROR_TYPE ResetFirmware();
    virtual DWORD GetSMBUSDataType();
    virtual STRUCT_ENUM_ERROR_TYPE SetSMBUSDataType(DWORD ulSMBUSDataType);
    virtual BYTE GetDeviceCount();
    virtual STRUCT_ENUM_ERROR_TYPE RemoveDevice();
    virtual STRUCT_ENUM_ERROR_TYPE SetFTDIGetAck(BOOL bEnable);
    virtual BOOL GetFTDIGetAckStatus();
    virtual STRUCT_ENUM_ERROR_TYPE GetUsbDevicePath(BYTE ucIndex, TCHAR* pcszDevicePath);
    virtual STRUCT_ENUM_ERROR_TYPE SelectUsbByDevicePath(TCHAR* pcszDevicePath);
    virtual STRUCT_ENUM_ERROR_TYPE SelectUsbByIndex(BYTE ucIndex);
    virtual void SetCmdLine(TCHAR *pcCmd);
    virtual STRUCT_ENUM_ERROR_TYPE I2CWriteSegment(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE I2CReadSegment(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
    virtual STRUCT_ENUM_ERROR_TYPE SendUsbPacket(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData);
    virtual STRUCT_ENUM_ERROR_TYPE ReceiveUsbPacket(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData);

};
