/********************************************************************************/
/*   The  Software  is  proprietary,  confidential,  and  valuable to Realtek   */
/*   Semiconductor  Corporation  ("Realtek").  All  rights, including but not   */
/*   limited  to  copyrights,  patents,  trademarks, trade secrets, mask work   */
/*   rights, and other similar rights and interests, are reserved to Realtek.   */
/*   Without  prior  written  consent  from  Realtek,  copying, reproduction,   */
/*   modification,  distribution,  or  otherwise  is strictly prohibited. The   */
/*   Software  shall  be  kept  strictly  in  confidence,  and  shall  not be   */
/*   disclosed to or otherwise accessed by any third party.                     */
/*   c<2010> - <2014>                                                           */
/*   The Software is provided "AS IS" without any warranty of any kind,         */
/*   express, implied, statutory or otherwise.   						        */  
/********************************************************************************/

#ifndef _COMM_PLUGIN_EXPORT_H_
#define _COMM_PLUGIN_EXPORT_H_
#include "../../../Tool_Common/RsCommon/ErrorDefine.h"
#include "../../../CpComm/Comm_Export/CpCommInclude.h"
#include <iostream>
using namespace std;

//////////////////////////////////////////////////////////////////////////
// function define
//////////////////////////////////////////////////////////////////////////
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdInitialDev)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdReleaseDev)();
typedef STRUCT_ENUM_COMM_ID (*func_rsdGetCommID)();
typedef void (*func_rsdGetCommName)(TCHAR *pcName, WORD usLength);
typedef WORD (*func_rsdGetI2CPageLength)();
typedef WORD (*func_rsdGetNativePageLength)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdI2CWrite)(BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdI2CRead)(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdI2CWriteByte)(BYTE ucSlave, BYTE ucSub, BYTE ucValue);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdI2CCurrentRead)(BYTE ucSlave, WORD usLength, BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdI2CWordWrite)(BYTE ucSlave, WORD usSub, WORD usLength, const BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdI2CWordRead)(BYTE ucSlave, WORD usSub, WORD usLength, BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdAdjustOption)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSetI2CSpeed)(WORD usSpeed);
typedef WORD (*func_rsdGetI2CSpeed)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSetAuxMode)(STRUCT_AUXMODE_STRUCT stAuxMode);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSetWaitingMode)(STRUCT_WAITING_STRUCT stWaiting);
typedef STRUCT_WAITING_STRUCT (*func_rsdGetWaitingMode)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdNativeWrite)(INT nAddress, WORD usLength, const BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdNativeRead)(INT nAddress, WORD usLength, BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSetConfigFilePath)(TCHAR *pcConfigFilePath);
typedef void * (*func_rsdGetDeviceHandler)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdResetFirmware)();
typedef DWORD (*func_rsdGetSMBUSDataType)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSetSMBUSDataType)(DWORD ulSMBUSDataType);
typedef BYTE (*func_rsdGetDeviceCount)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdRemoveDevice)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSetFTDIGetAck)(BOOL bEnable);
typedef BOOL (*func_rsdGetFTDIGetAckStatus)();
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdGetUsbDevicePath)(BYTE ucIndex, TCHAR* pcszDevicePath);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSelectUsbByDevicePath)(TCHAR* pcszDevicePath);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSelectUsbByIndex)(BYTE ucIndex);
typedef void (*func_rsdSetCmdLine)(TCHAR *pcCmd);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdI2CWriteSegment)(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdI2CReadSegment)(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdSendUsbPacket)(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData);
typedef STRUCT_ENUM_ERROR_TYPE (*func_rsdReceiveUsbPacket)(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData);

extern func_rsdInitialDev rsdInitialDev;
extern func_rsdReleaseDev rsdReleaseDev;
extern func_rsdGetCommID rsdGetCommID;
extern func_rsdGetCommName rsdGetCommName;
extern func_rsdGetI2CPageLength rsdGetI2CPageLength;
extern func_rsdGetNativePageLength rsdGetNativePageLength;
extern func_rsdI2CWrite rsdI2CWrite;
extern func_rsdI2CRead rsdI2CRead;
extern func_rsdI2CWriteByte rsdI2CWriteByte;
extern func_rsdI2CCurrentRead rsdI2CCurrentRead;
extern func_rsdI2CWordWrite rsdI2CWordWrite;
extern func_rsdI2CWordRead rsdI2CWordRead;
extern func_rsdAdjustOption rsdAdjustOption;
extern func_rsdSetI2CSpeed rsdSetI2CSpeed;
extern func_rsdGetI2CSpeed rsdGetI2CSpeed;
extern func_rsdSetAuxMode rsdSetAuxMode;
extern func_rsdSetWaitingMode rsdSetUsbWaitingMode;
extern func_rsdGetWaitingMode rsdGetWaitingMode;
extern func_rsdNativeWrite rsdNativeWrite;
extern func_rsdNativeRead rsdNativeRead;
extern func_rsdSetConfigFilePath rsdSetConfigFilePath;
extern func_rsdGetDeviceHandler rsdGetDeviceHandler;
extern func_rsdResetFirmware rsdResetFirmware;
extern func_rsdGetSMBUSDataType rsdGetSMBUSDataType;
extern func_rsdSetSMBUSDataType rsdSetSMBUSDataType;
extern func_rsdGetDeviceCount rsdGetDeviceCount;
extern func_rsdRemoveDevice rsdRemoveDevice;
extern func_rsdSetFTDIGetAck rsdSetFTDIGetAck;
extern func_rsdGetFTDIGetAckStatus rsdGetFTDIGetAckStatus;
extern func_rsdGetUsbDevicePath rsdGetUsbDevicePath;
extern func_rsdSelectUsbByDevicePath rsdSelectUsbByDevicePath;
extern func_rsdSelectUsbByIndex rsdSelectUsbByIndex;
extern func_rsdSetCmdLine rsdSetCmdLine;
extern func_rsdI2CWriteSegment rsdI2CWriteSegment;
extern func_rsdI2CReadSegment rsdI2CReadSegment;
extern func_rsdReceiveUsbPacket rsdReceiveUsbPacket;
extern func_rsdSendUsbPacket rsdSendUsbPacket;

BOOL rsdLoadDeviceDllFile(TCHAR * pFileName);
void rsdFreeDeviceDllFile();

#endif // End of #ifndef _COMM_PLUGIN_EXPORT_H_