#ifndef _COMM_H
#define _COMM_H
#include "Comm_Export/CpCommInclude.h"
#include "../Tool_Common/RsCommon/ErrorDefine.h"
#include "../Tool_Common/RsDataType.h"
#include "../Tool_Common/CpRsString.h"
#include <vector>
typedef struct tagCommInfo
{
    CCpRsString strDllFile;
    unsigned int  usDeviceVersion;
    STRUCT_ENUM_COMM_ID enumCommID;
    TCHAR carrCommName[256];
}STRUCT_DEVICE_INFO, *LPSTRUCT_DEVICE_INFO;
typedef std::vector <STRUCT_DEVICE_INFO> VECTORDEVICEINFO;

#ifdef __cplusplus
extern "C" {
#endif
STRUCT_ENUM_ERROR_TYPE Initiallize();
void SetCurWorkingPath(TCHAR *pcDirPath);
int GetCommCount();
STRUCT_ENUM_COMM_ID GetCommID();
void GetCommName(TCHAR *pcName);
void GetAllCommName(TCHAR pcNames[][256]);
STRUCT_ENUM_ERROR_TYPE GetCommFile(STRUCT_COMM_INFO *pstCommVer);
STRUCT_ENUM_ERROR_TYPE SetCommByIndex(WORD usCommIndex);
STRUCT_ENUM_ERROR_TYPE SetCommByID(STRUCT_ENUM_COMM_ID enumCommID);
void SetDebugSlave(BYTE ucDebugSlave);
void SetIspSlave(BYTE ucIspSlave);
void SetIspContinuousSlave(BYTE ucIspContinuousSlave);
BYTE GetDebugSlave();
BYTE GetIspSlave();
BYTE GetIspContinuousSlave();
STRUCT_ENUM_ERROR_TYPE SetDebugMode(STRUCT_ENUM_DEBUG_TYPE enumDebugType);
STRUCT_ENUM_DEBUG_TYPE GetDebugMode();
WORD GetI2CPageLength();
WORD GetNativePageLength();
STRUCT_ENUM_ERROR_TYPE I2CWrite(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CRead(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CWriteByte(BYTE ucSlave, BYTE ucSub, BYTE ucValue);
STRUCT_ENUM_ERROR_TYPE I2CCurrentRead(BYTE ucSlave, WORD usLength, LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CWordWrite(BYTE ucSlave, WORD usSub, WORD usLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CWordRead(BYTE ucSlave, WORD usSub, WORD usLength, LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CWriteEx(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf, BOOL bAuto);
STRUCT_ENUM_ERROR_TYPE I2CReadEx(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf, BOOL bAuto);
STRUCT_ENUM_ERROR_TYPE I2CCurrentReadEx(BYTE ucSlave, WORD usLength, LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CWordWriteEx(BYTE ucSlave, WORD usSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE I2CWordReadEx(BYTE ucSlave, WORD usSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE AdjustOption();
STRUCT_ENUM_ERROR_TYPE SetI2CSpeed(WORD usSpeed);
WORD GetI2CSpeed();
STRUCT_ENUM_ERROR_TYPE SetAuxMode(STRUCT_AUXMODE_STRUCT stAuxMode);
STRUCT_ENUM_ERROR_TYPE SetWaitingMode(STRUCT_WAITING_STRUCT stWaiting);
STRUCT_WAITING_STRUCT GetWaitingMode();

STRUCT_ENUM_ERROR_TYPE ReadReg(BYTE ucReg, BYTE* pucValue);
STRUCT_ENUM_ERROR_TYPE WriteReg(BYTE ucReg, BYTE ucValue);
STRUCT_ENUM_ERROR_TYPE ReadRegs(BYTE ucReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteRegs(BYTE ucReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteRegBit(BYTE ucReg, BYTE ucAnd, BYTE ucOr);
STRUCT_ENUM_ERROR_TYPE WritePortRegBit(BYTE ucAddrReg, BYTE ucDataReg, BYTE ucAnd, BYTE ucOr);
STRUCT_ENUM_ERROR_TYPE ReadRegEx(WORD usReg, BYTE* pucValue);
STRUCT_ENUM_ERROR_TYPE WriteRegEx(WORD usReg, BYTE ucValue);
STRUCT_ENUM_ERROR_TYPE ReadRegsEx(WORD usReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteRegsEx(WORD usReg, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteRegBitEx(WORD usReg, BYTE ucAnd, BYTE ucOr);
STRUCT_ENUM_ERROR_TYPE WritePortRegBitEx(WORD usAddrReg, WORD usDataReg, BYTE ucAnd, BYTE ucOr);
STRUCT_ENUM_ERROR_TYPE ReadSysDevice(BYTE ucSlave, BYTE ucSub, BYTE ucLength, LPBYTE pucBuf, STRUCT_ENUM_SYS_DEVICE_CMD_TYPE enumCmdType);
STRUCT_ENUM_ERROR_TYPE WriteSysDevice(BYTE ucSlave, BYTE ucSub, BYTE ucLength, LPBYTE pucBuf, STRUCT_ENUM_SYS_DEVICE_CMD_TYPE enumCmdType);
STRUCT_ENUM_ERROR_TYPE ReadWordSysDevice(BYTE ucSlave, WORD usSub, BYTE ucLength, LPBYTE pucBuf, STRUCT_ENUM_SYS_DEVICE_CMD_TYPE enumCmdType);
STRUCT_ENUM_ERROR_TYPE WriteWordSysDevice(BYTE ucSlave, WORD usSub, BYTE ucLength, LPBYTE pucBuf, STRUCT_ENUM_SYS_DEVICE_CMD_TYPE enumCmdType);

STRUCT_ENUM_ERROR_TYPE WriteMcuReg(WORD usReg, BYTE ucValue);
STRUCT_ENUM_ERROR_TYPE WriteMcuRegs(WORD usReg, WORD usLenth, BYTE *pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE ReadMcuRegs(WORD usReg, WORD usLenth, BYTE *pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE ReadMcuReg(WORD usReg, BYTE* pucValue);
STRUCT_ENUM_ERROR_TYPE WriteMcuRegBit(WORD usReg, BYTE ucAnd, BYTE ucOr);
STRUCT_ENUM_ERROR_TYPE WriteContinuousMcuReg(BYTE ucSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE ReadContinuousMcuReg(BYTE ucSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);

STRUCT_ENUM_ERROR_TYPE WriteRegEx(WORD usReg, BYTE ucValue);
STRUCT_ENUM_ERROR_TYPE SendUsbPacket(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData);
STRUCT_ENUM_ERROR_TYPE ReceiveUsbPacket(BYTE bRequest, WORD usValue, WORD usIndex, WORD usLength, void * pData);

STRUCT_ENUM_ERROR_TYPE ScalerStop();
STRUCT_ENUM_ERROR_TYPE ScalerRun();
STRUCT_ENUM_ERROR_TYPE EnterIspMode(WORD usRetryTimes);

STRUCT_ENUM_ERROR_TYPE InitialDev();
STRUCT_ENUM_ERROR_TYPE ReleaseDev();
void * GetDeviceHandler();
STRUCT_ENUM_ERROR_TYPE ResetFirmware();
BYTE GetDeviceCount();
STRUCT_ENUM_ERROR_TYPE RemoveDevice();
STRUCT_ENUM_ERROR_TYPE SetFTDIGetAck(BOOL bEnable);
BOOL GetFTDIGetAckStatus();
STRUCT_ENUM_ERROR_TYPE GetUsbDevicePath(BYTE ucIndex, TCHAR* pcszDevicePath);
STRUCT_ENUM_ERROR_TYPE SelectUsbByDevicePath(TCHAR* pcszDevicePath);
STRUCT_ENUM_ERROR_TYPE SelectUsbByIndex(BYTE ucIndex);

STRUCT_ENUM_ERROR_TYPE AutoDetectSlaveAddr();
STRUCT_ENUM_ERROR_TYPE DDCCIWrite(BYTE ucSlave, BYTE ucSub, BYTE ucLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE DDCCIRead(BYTE ucSlave, BYTE ucSub, BYTE ucLength, LPBYTE pucBuf);

STRUCT_ENUM_ERROR_TYPE I2CMasterInitial(STRUCT_ENUM_IIC_MASTER_SPEED enumI2cMasterSpeed);
STRUCT_ENUM_ERROR_TYPE I2CMasterCurrentRead(BYTE ucSlave, WORD usLength, LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CMasterCurrentReadEx(BYTE ucSlave, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE I2CMasterRead(BYTE ucSlave, BYTE ucSub, WORD usLength, LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CMasterReadEx(BYTE ucSlave, BYTE ucSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE I2CMasterWordRead(BYTE ucSlave, WORD usSub, WORD usLength, LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CMasterWordReadEx(BYTE ucSlave, WORD usSub, WORD usLength, LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE I2CMasterCurrentWrite(BYTE ucSlave, WORD usLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CMasterCurrentWriteEx(BYTE ucSlave, WORD usLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CMasterWrite(BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CMasterWriteByte(BYTE ucSlave, BYTE ucSub, BYTE ucValue);
STRUCT_ENUM_ERROR_TYPE I2CMasterWriteEx(BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE I2CMasterWordWrite(BYTE ucSlave, WORD usSub, WORD usLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CMasterWordWriteEx(BYTE ucSlave, WORD usSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteFlashData(DWORD ulFlashAddr, WORD usLen, LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE ReadFlashData(DWORD ulFlashAddr, WORD usLen, LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE Read32BitRegEx(DWORD ulReg, DWORD* pulValue);
STRUCT_ENUM_ERROR_TYPE Write32BitRegEx(DWORD ulReg, DWORD ulValue);
STRUCT_ENUM_ERROR_TYPE Read32BitRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE Write32BitRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE ReadDDRRegEx(DWORD ulReg, DWORD* pulValue);
STRUCT_ENUM_ERROR_TYPE WriteDDRRegEx(DWORD ulReg, DWORD ulValue);
STRUCT_ENUM_ERROR_TYPE ReadDDRRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE WriteDDRRegsEx(DWORD ulReg, WORD usLength, LPDWORD pulBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIReg(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf);
STRUCT_ENUM_ERROR_TYPE WritePWM2SPIReg(BYTE ucDevIndex, BYTE ucRegStartAddr, BYTE ucLength, BYTE *pucBuf);
STRUCT_ENUM_ERROR_TYPE ReadPWM2SPIDev(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf);
STRUCT_ENUM_ERROR_TYPE WritePWM2SPIDev(BYTE ucDevIndex, BYTE ucPwmStartIndex, BYTE ucPwmNum, WORD *pusBuf);
STRUCT_ENUM_ERROR_TYPE I2CWriteSegment(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CWriteSegmentEx(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE I2CReadSegment(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE I2CReadSegmentEx(BYTE ucSegSlave, BYTE ucSegAddr, BYTE ucSlave, BYTE ucSub, WORD usLength, const LPBYTE pucBuf, STRUCT_ENUM_INC_TYPE enumInc);
STRUCT_ENUM_ERROR_TYPE NativeWrite(INT nAddress, WORD usLength, const LPBYTE pucBuf);
STRUCT_ENUM_ERROR_TYPE NativeRead(INT nAddress, WORD usLength, LPBYTE pucBuf);
void SetSettingFilePath(TCHAR *pcConfigFilePath);
DWORD GetSMBUSDataType();
STRUCT_ENUM_ERROR_TYPE SetSMBUSDataType(DWORD ulSMBUSDataType);
void SetCmdLine(TCHAR *pcCmd);
STRUCT_ENUM_ERROR_TYPE AutoEnterIspMode(WORD usRetryTimes);
STRUCT_ENUM_ERROR_TYPE SetSpecialCommType(STRUCT_ENUM_SPECIAL_COMM_TYPE enumSpecialCommType);
STRUCT_ENUM_SPECIAL_COMM_TYPE GetSpecialCommType();

#ifdef __cplusplus
} // extern "C"
#endif

#endif
